CSEG    SEGMENT PARA PUBLIC 'CODE'
        ASSUME  CS:CSEG,ES:CSEG,DS:CSEG
start:
;----------------------------------------------------------------------------
;                       DEVICE DRIVER HEADER
;----------------------------------------------------------------------------
NEXT_DEV        DD      -1              ;POINTER TO NEXT DEVICE
ATTRIBUTE       DW      8000H           ;CHARACTER TYPE DEVICE
STRATEGY        DW      DEV_STRATEGY    ;POINTER TO DEVICE STRATEGY
INTERRUPT       DW      DEV_INT         ;POINTER TO DEV_INT
DEV_NAME        DB      'MAP_HD  '      ;DEVICE INDENTIFIER
;-----------------------------------------------------------------------------
;               F U N C T I O N  T A B L E
;
;       This is the table of procedures which are called to service each type
; of device driver request from MS-DOS.
;-----------------------------------------------------------------------------
;-----------------------------------------------------------------------------
;               WORKING VARIABLES FOR BUFFERRING OF OUTPUT
;-----------------------------------------------------------------------------
;-----------------------------------------------------------------------------
;                               DEVICE STRATEGY ROUTINE
;
;       This procedure gets the request header from MS-DOS and sets up RH_SEG
; as the pointer used in the buffer driver for manipulation of the request
; header
;-----------------------------------------------------------------------------
DEV_STRATEGY    PROC    FAR
        MOV     WORD PTR CS:[RH_SEG],BX         ;SAVE THE REQUEST HEADER SEGMENT
        MOV     WORD PTR CS:[RH_SEG+2],ES       ;SAVE THE REQUEST HEADER OFFSET
        mov     cs:bseg,cs
        RET
DEV_STRATEGY    ENDP
rh_seg   dd  0
;------------------------------------------------------------------------------
;                               DEVICE INTERRUPT HANDLER
;       This procedure is called each time MS-DOS calls the driver.  Its task
; is to branch control to the proper procedure to service the request.
;-----------------------------------------------------------------------------
DEV_INT PROC    FAR
       push    ax
       push    bx
       push    cx
       push    dx
       push    bp
       push    si
       push    di
       push    ds
       push    es
       les    bx,cs:rh_seg
       cmp    byte ptr es:[bx]+2,0
       jne    not_for_us
       push   bx
       push   es
       call   init2
       pop    es
       pop    bx
not_for_us:
       or   es:word ptr [bx]+3,100h
       pop    es
       pop    ds
       pop    di
       pop    si
       pop    bp
       pop    dx
       pop    cx
       pop    bx
       pop    ax
        ret
DEV_INT ENDP
;       INIT ROUTINE
INIT    PROC    NEAR
bseg   dw  0
bios   db 8020h dup(0)
init2:
        mov     ax,cs
        mov     ds,ax
        lea     si,himess
        call    tty
; get the length of the c800 bios
        mov     ax,0c800h
        mov     ds,ax
        cmp     word ptr ds:[0],0AA55h
        je      ok_bios
bad_bios:
        jmp     bad_end
ok_bios:
        mov     dh,byte ptr ds:[2]
        mov     dl,0
        inc     dx
        shl     dx,1
        mov     bp,dx    ; length of bios area
        cmp     dx,0
        jle     bad_bios
; move the bios into the bios area
        mov     ax,offset bios
        add     ax,15
        mov     cl,4
        shr     ax,cl
        mov     dx,cs
        add     dx,ax
        mov     es,dx    ; dx has the target segment
        mov     si,0
        mov     di,0
        mov     cx,bp
        cld
rep     movsb
; now scan for c800h in the interrupt area and replace with
        mov     ax,0
        mov     es,ax
        mov     di,2
        mov     cx,128
        cli
bloop:
        cmp     word ptr es:[di],0c800h
        jne     no_f
        push    es
        pop     es
        mov     word ptr es:[di],dx
no_f:
        add     di,4
        loop    bloop
        sti
; check out dos for similar occurrences
        mov     di,0
        mov     ax,70h
        mov     es,ax
        mov     cx,512
dloop:
        cmp     word ptr es:[di],0c800h
        jne     no_f1
        mov     word ptr es:[di],dx
        jmp     d_end
no_f1:
        inc     di
        loop    dloop
d_end:
        mov     ax,cs
        mov     ds,ax
        mov     es,ax
; set up length of data
        MOV     dx,OFFSET bios          ;POINT TO THE START OF OUR INIT ROUTINE
        add     dx,bp  ; length of bios
        add     dx,15
        MOV     CL,04                   ;AMOUNT TO SHIFT RIGHT
        SHR     DX,CL                   ;DO IT
        MOV     AX,CS                   ;GET CURRENT CODE SEGMENT
        ADD     AX,DX                   ;ADD TO OUR SEGMENT LENGTH
        LDS     SI,RH_SEG               ;FILL IN THE REQUEST HEADER THE POINT
        MOV     [SI+0EH],AX             ;PAST OUR USEAGE
        MOV     [SI+10H],CS
        mov     ax,cs
        mov     ds,ax
        mov     es,ax
        mov     ax,bp
        lea     di,mdec+4
        mov     cx,5
mloop:
        push    cx
        mov     dx,0
        mov     cx,10
        div     cx
        or      dl,30h
        mov     es:[di],dl
        dec    di
        pop    cx
        loop   mloop
        lea    si,mdec
        mov    cx,4
zloop:
        cmp    byte ptr ds:[si],'0'
        jne    no_lead
        mov    byte ptr ds:[si],20h
        loop   zloop
no_lead:
        lea     si,imess
        call    tty
        ret
bad_end:
        mov     ax,cs
        mov     ds,ax
        mov     es,ax
        MOV     dx,OFFSET init          ;POINT TO THE START OF OUR INIT ROUTINE
        add     dx,15
        MOV     CL,04                   ;AMOUNT TO SHIFT RIGHT
        SHR     DX,CL                   ;DO IT
        MOV     AX,CS                   ;GET CURRENT CODE SEGMENT
        ADD     AX,DX                   ;ADD TO OUR SEGMENT LENGTH
        LDS     SI,RH_SEG               ;FILL IN THE REQUEST HEADER THE POINT
        MOV     [SI+0EH],AX             ;PAST OUR USEAGE
        MOV     [SI+10H],CS
        mov     ax,cs
        mov     ds,ax
        mov     es,ax
        lea     si,emess
        call    tty
        ret
tty:
       cld
       lodsb
       cmp  al,0
       je   done
       mov  ah,14
       int  10h
       jmp  tty
done:
       ret
INIT    ENDP
himess db 13,10,'MAP_HD, XT Bios Mover',13,10
       db 'Copyright 1988 by Keith P. Graham',13,10,0
imess  db 'Found BIOS at C800:0 and moved '
mdec   db '00000 bytes to low memory',13,10,10,0
emess  db 7,'C800 Bios signature not found, Install aborted',13,10,0
CSEG    ENDS
        END   start
