; this routine will open an arc file and jmp throug the files
; looking for a file
;
;struct heads        /* archive entry header format */
;{   char name[$$fnlen];       /* file name */
;    long size;           /* size of file, in bytes */
;    int date;           /* creation date */
;    int time;           /* creation time */
;    int crc;        /* cyclic redundancy check */
;    long length;           /* true file length */
;}   ;
; length of archead is  27 bytes max
archead db  26
arcvers db  8
arcname db 13 dup(0)
arcsizel dw  0
arcsizeh dw  0
arcdate dw  0
arctime dw  0
arccrc  dw  0
arclen  dd  0
left_bracket db '[$'
right_bracket db ']$'
;
ahandle   dw  0
arc_read proc near
;
;     check out the arc
;
; open the input arc
       lea  dx,filename
       mov  ah,3dh
       mov  al,0
       int  21h
       jnc  good_open
       ret
good_open:
       mov  ahandle,ax
top_arc:
       mov  bx,ahandle
       lea  dx,archead
       mov  cx,29
       mov  ah,3fh
       int  21h
       jc   bad_arc_read
       cmp  ax,0
       je   bad_arc_read
       cmp  ax,cx
       je   good_read
bad_arc_read:
       call  end_read
       stc
       ret
good_read:
       cmp  archead,0
       je   bad_arc_read
       cmp  archead,26
       jne  bad_arc_read
       cmp  arcvers,0
       je   bad_arc_read
; check to see if arcname matches a graphics file type
found_arc:
; uppercase the arcname
       lea    si,arcname
       mov    di,si
       mov    cx,13
       cld
       mov    al,'.'
repne     scasb
       jne  bad_arc_read
       push  di
       mov   si,di
arc_u_loop:
       lodsb
       cmp    al,0
       je     done_upper
       cmp    al,'a'
       jl     arc_upp
       cmp    al,'z'
       jg     arc_upp
       sub    al,32
arc_upp:
       stosb
       loop   arc_u_loop
done_upper:
       pop    si
       lodsb
       cmp    al,'G'
       je     got_agif
       cmp    al,'M'
       je     got_amac
       cmp    al,'P'
       je     got_aPCX
       jmp  next_arc
got_agif:
       lodsb
       cmp    al,'I'
       jne    next_arc
       lodsb
       cmp    al,'F'
       jne    next_arc
       mov    gif,1
       mov    ax,2
       jmp    get_arc_file
got_amac:
       lodsb
       cmp    al,'A'
       jne    next_arc
       lodsb
       cmp    al,'C'
       jne    next_arc
       mov    mac,1
       mov    ax,3
       jmp    get_arc_file
got_apcx:
       lodsb
       cmp    al,'C'
       jne    next_arc
       lodsb
       cmp    al,'C'
       je     got_apcc
got_apcc:
       cmp    al,'X'
       jne    next_arc
       mov    pcx,1
       mov    ax,4
       jmp    get_arc_file
;
next_arc:
;
; now seek the next record
       mov   cx,word ptr arcsizeh
       mov   dx,word ptr arcsizel
       mov   ah,42h
       mov   al,1
       mov   bx,ahandle
       int   21h
       jnc   good_arc_seek
       jmp   bad_arc_read
good_arc_seek:
       jmp   top_arc
end_read:
; close the ahandle
       mov   bx,ahandle
       mov   ah,3eh
       int   21h
       ret
get_arc_file:
       push  ax
       call  end_read  ; close the file
; we have the name of the arc file in filename
; we have the name of the temp file in tempdir
; we have the name of the arced graphic in arcname
; build the unarc command in arcer
;
; find the end of the arcer command
       mov  cx,64
       lea  di,arcer
       mov  al,0
repne   scasb
       dec  di
       mov  si,di
       mov al,20h
       stosb
;
;
; now get the arc file name to unarc
       lea  si,filename
       mov  cx,64
gaf1:
       lodsb
       cmp   al,0
       je   gaf2
       stosb
       loop  gaf1
gaf2:
       mov  al,20h
       stosb
; if its pkxarc we go arcfile name dir
; if its arce its arcdir arcfile name
       cmp  word ptr arcer+1,'XK'
       je  pkxarc
; doint arcname first, this is the name of the file in the arc
       lea  si,arcname
       mov  cx,13
gaf3:
       lodsb
       cmp  al,0
       je   gaf4
       stosb
       loop gaf3
gaf4:
       mov  al,20h
       stosb
pkxarc:
; now get the dir where it goes
       lea  si,tempdir
gaf5:
       lodsb
       cmp  al,0
       je   gaf6
       stosb
       loop gaf5
gaf6:
       cmp  byte ptr es:[di-1],':'
       jne   gaf6a
       mov  al,'\'
       stosb
gaf6a:
       mov al,20h
       stosb
       cmp  word ptr arcer+1,'XK'
       jne  arce
; now get the arcname to pull out of arc
       lea  si,arcname
       mov  cx,13
gaf7a:
       lodsb
       cmp  al,0
       je   gaf8a
       stosb
       loop gaf7a
gaf8a:
       mov  al,20h
       stosb
arce:
       mov  ax,'N>'
       stosw
       mov  ax,'LU'
       stosw
       mov  al,' '
       stosb
       mov  al,20h
       stosb
       mov  al,13
       stosb
       lea  ax,arcer
       sub  di,ax
       mov  ax,di
       add  ax,3
       mov  asciiz,al  ; count of bytes in asciiz
; now the filename has changed because it exists somewhere else as a
; graphics file
       lea di,filename
       lea si,tempdir
       mov  cx,64
gaf7:
       lodsb
       cmp  al,0
       je   gaf8
       stosb
       loop gaf7
gaf8:
       mov  al,'\'
       stosb
       lea si,arcname
       mov  cx,13
gaf9:
       lodsb
       cmp  al,0
       je   gafa
       stosb
       loop gaf9
gafa:
       mov  al,0
       stosb

       mov   bx,ahandle
       mov   ah,3eh
       int   21h
       pop  ax
       clc
       ret
arc_read endp
