; this is the mirage external protocol program
;
CSEG	SEGMENT PARA PUBLIC 'CODE'
ASSUME CS:CSEG,DS:CSEG,SS:CSEG,ES:CSEG ;ALREADY SET BY DOS LOADER
ORG	100H
     extrn _curr_mode:near
     extrn _get_best_mode:near
     extrn _graphics_line:near
     extrn _set_graphics:near
ENTPT:	JMP	START
print macro string
     lea  dx,string
     mov  ah,9
     int  21h
     endm
hello  db 'Mirage Remote Communications Protocol',13,10
     db 'Version 1.01, Level 2.00',13,10
     db 'Copyright 1988 by Keith P. Graham',13,10,'$'
help1   db 13,10,'Press Alt-F10 to return to Calling Program',13,10
     db '$'
ct_level	db 2  ; this is the ct level guy
start_mode	dw  0
send_best_mode	db '#'
best_mode	dw  0
grbuffer	db 640 dup(0)
grlength	dw 0
grline_no	dw 0
lines_sent	dw 0
color_map	db  256*3 dup(0)
kbd_phase	dw 0
vid_phase	dw 0
graphics_on	db 0  ; tells if the graphics mode has been set yet
host_level	db 0  ; which hos level to use
grbuffer2	db 1720 dup(0)
include c:fd.asm
include c:qu.asm
START	PROC	NEAR
; first thing is to get the best mode
    	 print hello
     call _curr_mode
     mov  start_mode,ax
     call _get_best_mode
     mov  best_mode,ax
     print help1
     cmp     byte ptr ds:[5dh],'2'
     jne     no_cl_port
     mov     comport,1
no_cl_port:
     mov     dh,0
     mov     dl,comport
     call    initcom
comloop:
     clc
     mov     ah,1
     int     16h
     jz     nochar
     mov     ah,0
     int     16h
; have a character,
     cmp     ax,7100h
     jne     not_exit_ct
     jmp     exit_ct
not_exit_ct:
     cmp     ax,6800h
     jne     no_help
     call    help
no_help:
     mov     bx,kbd_phase
     shl     bx,1
     jmp     kbd_line[bx]
kbd_line  dw  full_screen,ttl,vt100 ; how to process keystrokes
ttl:
     cmp     al,0
     jne     send_ttl
     jmp     comloop
send_ttl:
     call    put_com
     jmp     comloop
vt100:
; process vt100 keystrokes here
     call    put_com
     jmp     comloop
full_screen:
     cmp     al,0
     jne     not_special
     push    ax
     call    put_com
     pop     ax
     mov     al,ah
not_special:
     call    put_com
     jmp     nochar
nochar:
     clc
     mov     ah,1
     int     16h
     jz     nochar2
     mov     ah,0
     int     16h
     cmp     al,27  ; esc
     jne     no_esc
     jmp     bad_rec
no_esc:
     cmp     al,11  ; ctrl-k
     jne     noctk
     jmp     bad_rec
noctk:
     cmp     ax,7100h ; alt f10
     jne     not_a_f10
     jmp     bad_rec
not_a_f10:
     jmp     nochar
nochar2:
     call   check_cd
     jnc    cont_g1
     jmp    exit_ct
cont_g1:
     call    get_buffer ; gets a character from the input buffer
     jnc     putchar
     jmp     comloop
putchar:
     call   check_cd
     jnc    cont_pc
     jmp    reset_mode
cont_pc:
     mov     bx,vid_phase
     shl     bx,1
     jmp     vid_line[bx]
vid_line dw    full_vid,tty_vid,vt100_vid,gr_vid1,gr_vid2,sync_up
         dw    sync_up2
;    full_vid = door ward graphics
;    tty_vid  = tty mode
;    vt00_vid = escape sequences
;    gr_vid1  = have received an f1
;    gr_vid2  = have received an * for a graphics line
;    sync_up  = wait for the syncs and be cool
;    sync_up2 = receiving syncs, waiting for something else
;
sync_up:
; this has to have a 7e in al anything else and its back to gr_vid1
     cmp  al,7eh
     je   got_a_7e
; if its not 7e it can be the next f1 a ctrl-k or a ctrl-x
     jmp  nochar      ; have a non-7e have to process is
got_a_7e:
     mov  vid_phase,6 ; next syncup phase
     jmp  nochar
sync_up2:
; have received the first syncup, wait for a non syncup
     cmp   al,7eh
     jne   non_sync
     jmp   nochar
non_sync:
; have a character after a sync must go to comloop
; what to do now with character?
     mov  vid_phase,0
     jmp  full_vid
     ;
;
tty_vid:
vt100_vid:
     mov     dx,1
     mov     ah,14
     int     10h
     jmp     comloop
full_vid:
; check and see if it is as special character
     mov     ah,0
     cmp     ax,0fch
     jg     not_emulated
     cmp     ax,0f2h
     jl     not_emulated
; have an ascii f2 to fa in al
     and     al,0fh
     sub     al,2
     shl     ax,1
     mov     bx,ax
     call    ds:emulate[bx]
     jmp     comloop
not_emulated:
     cmp     al,0f1h ; this is the graphics escape guy
     je     is_graphics_esc
     jmp     not_graphics
is_graphics_esc:
; the f1 character is sent by graphics. If the next charcter is
; the left bracket we have to send the best modes.
; left bracket is restore mode
     mov     vid_phase,3
     jmp     nochar
gr_vid1:
; here we are going through because we received the f1 character
; this is the very next character.
     cmp   al,'{'
     je    send_level
     cmp   al,'['
     je    send_mode
     cmp  al,']'
     je   reset_mode
     cmp  al,'&'
     je   get_color_mapx
     cmp  al,'*'
     je   receive_graphics1
     mov  vid_phase,0
     jmp  comloop
level_mess db 'Received level from host '
rlevel  db  ' ',13,10,'$'
get_color_mapx:
     jmp  get_color_map
send_level:
; he sent us a f1 { asking for level we must wiat for his level
     call get_com
     mov  host_level,al
     or  al,30h
     mov  rlevel,al
     print level_mess
     mov  al,'}'
     call  putbyte
     mov   al,ct_level
     call  putbyte
     mov   vid_phase,0
     jmp   comloop
send_mode:
     mov  vid_phase,0
     mov  al,'#'
     call  putbyte
     mov  ax,best_mode
     call putbyte
     jmp  nochar
reset_mode:
     jmp  exit_ct
receive_graphics1:
     cmp   graphics_on,1
     je    by_set_graphics
     push  ax
     mov   ax,best_mode
     push  ax
     call  _set_graphics
     mov   graphics_on,1
     pop  ax
by_set_graphics:
     mov   vid_phase,4  ; receive a graphics line
     jmp  nochar
get_color_map:
     call get_com
     mov  cl,al
     mov  ch,0
     lea  di,color_map
     cmp  cx,0
     jl   leave_map
     cmp  cx,768
     jle  get_map1
leave_map:
     jmp  comloop
exit_ct:
     call  flush_com
     call    decom
     cmp   graphics_on,0
     je    leave_ct
     mov  ax,start_mode
     mov   ah,0
     int   10h
leave_ct:
	int     20h
get_map1:
     push  cx
     call get_com
     stosb
     pop   cx
     loop  get_map1
     jmp  comloop
not_graphics:
     mov     dx,1
     mov     ah,14
     int     10h
     jmp     comloop
;
;
gr_vid2:
; here we enter because the first character after a f1 * is found
;
extrn vid_len:word,interlace:word
;
; have received a graphics send, the next 2 guys are the amount to recieve
; first character sent is the line number
     push  ax
     mov   ax,vid_len
     mul   interlace
     cmp   lines_sent,ax
     pop   ax
     jl    cont_g2a
bad_rec:
     call  ctrl_k
     mov  vid_phase,5 ; sync up phase
     jmp  comloop
cont_g2a:
; al has the character from the loop
     mov  cl,al
     call get_com
     jc   bad_rec
     mov  ch,al
     cmp  cx,0
     jl bad_rec
     cmp  cx,256
     jg bad_rec
; cx is the length of a line
     lea  di,grbuffer
     mov  grlength,cx
get_line1:
     call   get_com
     jc    bad_rec
     stosb
     loop  get_line1
; graphics buffer has the line
; put the graphics out the door
     inc  grline_no
     inc  lines_sent
     mov   cx,grlength
     lea  dx,grbuffer
; here we determine if we can use level 2
     cmp  host_level,2
     jl   no_comp
; here call the decompress scheme
;     int 3
     mov  dl,-1
     mov  bx,cx
     lea  si,grbuffer
     lea  di,grbuffer2
     call un_packbitsx
     mov  cx,di
     sub  cx,offset grbuffer2
     lea  dx,grbuffer2
no_comp:
     mov  ax,grline_no
     push cx
     push dx
     push ax
     call _graphics_line
     pop  ax
     pop  dx
     pop  cx
; wait for all the syncs
     mov  vid_phase,5 ; sync up phase
     jmp  nochar
;  the line has run out
ctrl_k:
     mov   al,11  ; control K
ctrl_x:
     call  putbyte
     mov   cx,2
     call  waitsec
     call  flush_com
     ret
next_gra:
     jmp   comloop
;
;
emulate dw e102,e103,e104,e105,e106,e107,e108,e109,e10a
     dw e10b,e10c
e102:
; set cursor position dx,bh
     call  get_com
     mov   dl,al
     call  get_com
     mov   dh,al
;     call  get_com
;     mov   bh,al
     mov   bh,0
     mov   ah,2
     int   10h
     ret
e103: ; read pos
e104: ; light pen
e105: ; active page
e108: ;read attribute
     ret
e106:
; set scroll up
     call  get_com  ;al
     mov   ah,6
     push  ax
     jmp   rest_scroll
e107:
; set scroll down
     call  get_com
     mov   ah,7
     push  ax
rest_scroll:
     call   check_cd
     jnc    cont_g7
     jmp    exit_ct
cont_g7:
     call  get_com
     mov   bh,al
     call  get_com
     mov   cl,al
     call  get_com
     call   check_cd
     jnc    cont_g8
     jmp    exit_ct
cont_g8:
     mov   ch,al
     call  get_com
     mov   dl,al
     call  get_com
     mov   dh,al
     pop   ax
     int   10h
     call   check_cd
     jnc    cont_g9
     jmp    exit_ct
cont_g9:
     ret
e109:
; write attribute and character
     call  get_com
     mov   ah,9
     push  ax
     call  get_com
     mov   bl,al
;     call  get_com
;     mov   bh,al
     mov   bh,0
     call   check_cd
     jnc    cont_ga
     jmp    exit_ct
cont_ga:
     call  get_com
     mov   cl,al
     call  get_com
     mov   ch,al
     pop   ax
     int   10h
     ret
e10a:
; write character
     call  get_com
     mov   ah,10
     push  ax
;     call  get_com
;     mov   bh,al
     mov   bh,0
     call  get_com
     mov   cl,al
     call  get_com
     mov   ch,al
     pop   ax
     int   10h
     ret
e10b:
     call  get_com
     mov   ah,9
     push  ax
     call  get_com
     mov   bl,al
     mov   bh,0
     pop   ax
     mov   cx,1
     int   10h
     ret
e10c:
     call  get_com
     mov   ah,10
     mov   bh,0
     mov   cx,1
     int   10h
     ret
get_com:
     push  bx
     push  cx
     push  dx
     push  di
     call   check_cd
     jnc    cont_gb
     stc
     pop   di
     pop  dx
     pop  cx
     pop  bx
     ret
cont_gb:
; this waits forever for a com character
     mov  cx,0
getcom1:
     push  cx
     mov   cx,0
gc2:
     push  cx
     call  get_buffer
     pop   cx
     jnc   gc3
     loop  gc2
gc3:
     pop   cx
     jnc   exit_gc
     loop  getcom1
     stc
     pop   di
     pop  dx
     pop  cx
     pop  bx
     ret
exit_gc:
     clc
     pop   di
     pop  dx
     pop  cx
     pop  bx
     ret
START	ENDP
help   proc near
     print help1
     ret
help  endp
CSEG	ENDS
	END	ENTPT
