;
; this is the mirage host program
;
;
; following are conditionals for compiling
macpic=1
pcxpic=0
tifpic=0
gifpic=0
print macro string
    lea  dx,string
    call printit
    endm
cseg     segment para public 'CODE'
     assume   cs:cseg,ds:cseg,ss:cseg,es:cseg
     org   100h
start: jmp  main
mess1  db 'MIRAGE PC Rockland On-Line Graphics Viewer',13,10
     db 'Version 1.01, Level 2.00 protocol',13,10
     db 'Copyright 1988 by Keith P. Graham',13,10,'$',1ah
mess2  db 13,10,'Preparing to transmit $'
mess3  db 13,10,'Enter view level:',13,10
     db     '    1. full size',13,10
     db     '    2. 1/4 size',13,10
     db     '    3. 1/16 size',13,10
     db     '    Q. quit',13,10
     db 13,10,'     $'
crlf   db 13,10,10,'$'
mess4  db 13,10,'You have 30 seconds to Enter MIRAGE View mode',13,10,'$'
error1 db 'Error on command line. Job Aborted',13,10,'$'
error2 db 'Error on configuration file. Job Aborted',13,10,'$'
error3 db 'Graphics Viewer can only handle '
     if macpic
     db 'MAC '
     endif
     if pcxpic
     db ', ZSoft PCX'
     endif
     if tifpic
     db ', TIFF'
     endif
     if gifpic
     db ', GIF'
     endif
     db   13,10
     db 'or ARC files containing these files.',13,10,'$'
error4 db 'No graphics file found in the ARC file',13,10,'$'
error5 db 'Time out waiting for protocol response',13,10,'$'
error6 db 'Not a valid graphics file header',13,10,'$'
error7 db 'Memory Allocation Error.',13,10,'$'
done_mess db ' Graphics Viewer is complete.',13,10
     db ' For the latest version of the viewer software',13,10
     db ' Call PC Rockland at (914) 353-2157',13,10,10,'$'
;
pressit db 13,10,'Press any key to continue....',13,10,10,'$'
handle   dw 0
filename db 129 dup(0)
tempdir  db 129 dup(0)
asciiz   db 0  ; this is the length arcer in case of execute
     db '/C '
arcer    db 129 dup(0)
esc0     db 0f1h,'[$' ; this starts graphics
esc4     db '~~~~~~~~',0f1h,']~~~$' ; this ends it
hash_segment dw  0
gbuffer   dw  0
arc     db  0
gif     db  0
mac     db  0
pcx     db  0
shrink   db  0
scr_mode db  0
save_di  dw  0
save_si  dw  0
save_cx  dw  0
save_bp  dw  0
color_map db 256*3 dup(0)
escl  db 0f1h,'{'
host_level db 2,'$'  ; this sends the user out level and asks for his
user_level db 0
;
include c:fd.asm
include c:arcread.asm
include c:exec.asm
include c:gfiles.asm
include c:qp.asm
printit:
; this does the same as function 9 except it uses 10h 14
    push  si
    cld
    mov   si,dx
pi_loop:
    lodsb
    cmp   al,'$'
    je    leave_pi
    mov   ah,14
    int 10h
    jmp  pi_loop
leave_pi:
    pop   si
    ret
main     proc     near
    lea   sp,lstack+510
    print mess1
; shrink memory and allocate buffers and hash
    call shrink_mem

;
;
; check out the hash_segment
     jmp   goodget2
     MOV   AH,48h
     MOV   BX,640     ; 10k
     INT   21h
     jc    memory_error
     CMP   BX,1280
     JE    goodget2
memory_error:
    print error7
    mov   ax,4cffh
    int   21h
    int  20h
goodget2:
    mov    hash_segment,ax
; now the buffer for gif files
     MOV   AH,48h
     MOV   BX,2000h    ; 32k
     INT   21h
     jc    memory_error
     mov   gbuffer,ax
;
    call  check_command
    jnc   ok_command
    print error1
    mov   ax,4cffh
    int   21h
    int  20h
ok_command:
; have the file and the other info we can install com port stuff
    mov  dl,comport
    mov  dh,0
    call initcom
    call init10
    call init16
; verify paramters from config file
    call check_config
    jnc  ok_config
    print error2
    jmp   exit_g
ok_config:
;
; check_file_type
    lea di,filename
    call get_ext
    jnc   got_type
    jmp   exit_g
got_type:
; al = 1 for arc, 2 for gif, 3 for mac, 4 for pcx
; if its an arc handle it
    cmp  al,1
    jne  handle_graphics
    call  de_arc   ; de_arc unarcs the file and gets the new filename
    jc   bad_arcfile
    push ax
    lea  ax,asciiz
    mov  word ptr parmblock+2,ax
    call  exec_command
    pop  ax
    jc    bad_arcfile
    mov   arc,2
    jmp   ok_config
bad_arcfile:
    print error3
; should return here with the file name in filename
    jmp   exit_g
handle_graphics:
    push ax
    lea  di,filename
    cld
    mov cx,64
    mov  al,0
repne scasb
    mov  si,di
    mov al,'$'
    stosb
; check for carrier
    call  check_cd
    jnc   cont_g1
    jmp   exit_g
cont_g1:
    print mess1
    print mess2
    print filename
    print mess3
get_shrink:
    call  check_cd
    jnc   cont_g2
    jmp   exit_g
cont_g2:
    call  check_cd
    jc  bad_shrink
    mov  ah,1
    int  16h
    jz   cont_g2
    mov   ah,0
    int   16h
    cmp   al,'1'
    je    got_shrink
    cmp   al,'2'
    je    got_shrink
    cmp   al,'3'
    je    got_shrink
    cmp   al,'Q'
    je    bad_shrink
    cmp   al,'q'
    je    bad_shrink
    cmp   al,27
    je    bad_shrink
    mov   ah,14
    int   10h
    mov   al,7
    int   10h
    mov   al,8
    int   10h
    jmp   get_shrink
bad_shrink:
    jmp  exit_g
got_shrink:
    and  al,0fh
    mov  shrink,al
    print mess4
    mov  cx,15
wait_for_pound:
    push cx
    print esc0
    mov  cx,2
    call waitsec
    mov  ah,1
    int  16h
    jz   no_p
    mov  ah,0
    int  16h
;   cmp  al,0bh
;   je   timeout1
    cmp  al,18h
    je   timeout1
    cmp  al,'#'
    je   got_p
; got the pound sign
no_p:
    call  check_cd
    jnc   cont_g3
    jmp   exit_g
cont_g3:
    pop  cx
    loop wait_for_pound
     push cx
     jmp   timeout1
got_p:
    mov  ah,1
    int  16h
    jz   no_mode
    mov  ah,0
    int  16h
    jmp  got_mode
no_mode:
    mov  cx,2
    call waitsec
    pop  cx
    loop got_p
    push cx
timeout1:
    pop   cx
    pop  ax
    print error5
    jmp  exit_g
got_mode:
    pop   cx
    mov  scr_mode,al
; now open the file for input
; now do the request for level information
    print escl
    mov  cx,1
    call waitsec
    mov  ah,1
    int  16h
    jz   no_l
    mov  ah,0
    int  16h
    cmp  al,'}'
    jne  no_l
    mov  ah,1
    int  16h
    jz   no_l
    mov  ah,0
    int  16h
    mov  user_level,al
no_l:
    lea  dx,filename
    call open_input
    jnc   ggood_open
    pop   ax
    jmp  exit_g
ggood_open:
    call  check_cd
    jnc   cont_g4
    jmp   exit_g
cont_g4:
    pop  ax
; al = 1 for arc, 2 for gif, 3 for mac, 4 for pcx
    mov  bl,al
    mov  bh,0
    dec  bx
    dec  bx
    shl  bx,1
    push bx
    call cs:gheaders[bx]
    pop  bx
    jnc  good_header
head_error:
    print error6
    jmp  exit_g
shrink_sw  db  0
good_header:
; here the routines for handling the lines of graphics are handled
;int 3
    mov  shrink_sw,0
    mov  cx,height_pix
    mov  flow_control,1
transmit_loop:
    push bx
    push cx
    call  check_cd
    jnc   cont_g5
    jmp   exit_g

cont_g5:
    call cs:glines[bx]
    jc   done_glines
    cmp  mac,0
    je   done_glines
; see if the shrink is on
    cmp  shrink,1
    jle  by_tl_shrink
    inc  shrink_sw
    cmp  shrink_sw,1
    je   cont_glines
    cmp  shrink,2
    je   by_tl_shrink
    cmp  shrink_sw,4
    jne  cont_glines
by_tl_shrink:
    mov  shrink_sw,0
    mov  cx,width_bytes
    call flush_buffer
    jnc  cont_glines
    cmp   al,11
    je   done_glines
    mov   al,7eh
    call  putbyte
    mov   al,7eh
    call  putbyte
    jmp  gotq
cont_glines:
    pop  cx
    pop  bx
    loop transmit_loop
    push bx
    push cx
done_glines:
    mov  flow_control,0
    mov  cx,1
    call waitsec
    call  flush_com
    mov   al,7eh
    call  putbyte
    mov   al,7eh
    call  putbyte
    call flush_com
waitq:
    call  check_cd
    jc  gotq
    mov  ah,1
    int  16h
    jz   waitq
    mov   ah,0
    int   16h
    cmp   al,27
    je    gotq
    cmp   al,'Q'
    je    gotq
    cmp   al,'q'
    jne   done_glines
gotq:
    pop  cx
    pop  bx
    jmp  exit_g
flush_buffer:
; cx has the count of bytes to transmit
     push  si
     push  di
     push  bp
     push  ds
     push  es
     call  reset_segs
; first see if there is a horizontal shrink.
; two kinds of horizontal shrink, bit shrink for macs and pcx
; and a byte shrink for gifs
;
    cmp  gif,1
    jne   not_gif_comp
; gif shrink loop here
;
    jmp  no_shrink1
not_gif_comp:
    cmp  shrink,1
    jle  no_shrink1
    lea   si,tbuffer
    push  cx
    call half_it
    pop  cx
    shr  cx,1
    cmp  shrink,2
    jle  no_shrink1
    push  cx
    lea   si,tbuffer
    call half_it
    pop  cx
    shr  cx,1
;
no_shrink1:
    cmp  cx,0
    jg   cx_not_0
    mov  cx,1
cx_not_0:
; cx has the shrunk size
    lea  si,tbuffer
; cx has the count of bytes to transmit
; si points to the first byte
; we have to check and see if there are trailing 0's
    mov  di,si
    add  di,cx
    dec  di
    mov  al,0
    std
repe  scasb
    cld
    inc  cx
; done all of the stuff a level 0 user can do
;
    cmp  user_level,2
    jl   no_user_comp
    mov  bx,cx
    lea  si,tbuffer
    lea  di,tbuffer-64
    call packbitsx
    lea  si,tbuffer-64
    mov  cx,di
    sub  cx,si
;
no_user_comp:
; gline is full (up to 128 bytes) transmit , si points to gline
; transmit a stoh
    push  si
    push  cx
    mov  al,0f1h  ; transmit header
    call putbyte
    mov  al,'*'   ; transmit start
    call putbyte
    pop  cx
    push  cx
    mov   al,cl
    call putbyte
    pop   cx
    push  cx
    mov   al,ch
    call putbyte
    pop   cx
    pop   si
    call transmit
; now transmit the syncs
    mov  cx,8
sync_loop:
   push cx
    mov  al,7eh
    call  putbyte
    pop  cx
    loop  sync_loop
    mov  ah,1
    int  16h
    jz   cont_t
    mov  ah,0
    int  16h
    cmp  al,0bh   ; ctrl K stop transmitting and wait
    je   leave_fb
    cmp  al,18h    ; ctrl X time to leave
    je   leave_fb
cont_t:
    pop  es
    pop  ds
    pop  bp
    pop  si
    pop  di
    clc
    ret
leave_fb:
    push  ax
    call  flush_com
    mov  cx,1
    call  waitsec
    call  flush_com
    pop  ax
    pop  es
    pop  ds
    pop  bp
    pop  si
    pop  di
    stc
    ret
gheaders dw  gifheader,macheader,pcxheader
; header routines
macheader:
    call  _mac_header
    ret
; here we have the header send the next f symbol back with color
; info
    mov  al,0f1h  ; transmit header
    call putbyte
    mov  al,'&'   ; color map info
    call putbyte
    mov  al,0     ; 0 length color map
    call putbyte
    ret
pcxheader:
    stc
    ret
gifheader:
    call  _mac_header
    ret
; here we have the header send the next f symbol back with color
; info
    mov  al,0f1h  ; transmit header
    call putbyte
    mov  al,'&'   ; color map info
    call putbyte
    mov  al,0     ; 0 length color map
    call putbyte
    ret
    ret
;
glines dw  giflines,maclines,pcxlines
;
maclines:
    call mac_read
    jnc  good_mac_rec
bad_mread:
     stc
     ret
good_mac_rec:
    cmp  shrink,1
    je   leave_mread
    call mac_read
    jc   bad_mread
    cmp  shrink,2
    je   leave_mread
    call mac_read
    jc   bad_mread
    call mac_read
    jc   bad_mread
    mov  cx,width_bytes
    lea   si,tbuffer
leave_mread:
    clc
    ret
giflines:
     call gif_read
     ret
pcxlines:
     ret
;
;
exit_g:
    print esc4
    print crlf
    print esc4
    print crlf
    print done_mess
    cmp  arc,2
    jne  no_delete
; may have unarced so we must delete filename
    lea   dx,filename
    mov   ah,41h
     int  21h
no_delete:
    call  decom
    mov   ax,4cffh
    int   21h
    int  20h
main     endp
de_arc proc near
; this routine opens filename and searches for an graphics extension
; in the arc file
; if it finds it, it executes the arc command and
; replaces filename with the de-arced graphics
    call   arc_read
    ret
de_arc endp
get_ext:
    cld
    mov  cx,64
    mov  al,'.'
repne scasb
    je  got_dot
dot_err:
    print error3
    print pressit
waitq2:
    call  check_cd
    jc  dot_err_ex
    mov  ah,1
    int  16h
    jz   waitq2
    mov   ah,0
    int   16h
dot_err_ex:
    stc
    ret
got_dot:
    mov  si,di
    lodsb
    cmp  al,'A'
    jl   dot_err
    je   check_aa
    cmp  al,'a'
    je   check_aa
if  gifpic
    cmp  al,'G'
    jl   dot_err
    je   check_gg
    cmp  al,'g'
    je   check_gg
endif
if  macpic
    cmp  al,'M'
    jl   dot_err
    je   check_mm
    cmp  al,'m'
    je   check_mm
endif
if  pcxpic
    cmp  al,'P'
    jl   dot_err
    je   check_ppa
    cmp  al,'p'
    je   check_ppa
endif
    jmp  dot_err
check_ppa:
    jmp   check_pp
; ARC check
check_aa:
    lodsb
    cmp al,'R'
    je  check_ar
    cmp al,'r'
    jne  dot_err
check_ar:
    lodsb
    cmp  al,'C'
    je   got_arc
    cmp  al,'c'
    jne  dot_err
got_arc:
    mov  arc,1
    mov  al,1
    jmp  phase2
dot_errb:
    jmp  dot_err
;GIF check
check_gg:
    lodsb
    cmp al,'I'
    je  check_gi
    cmp al,'i'
    jne  dot_errb
check_gi:
    lodsb
    cmp  al,'F'
    je   got_gif
    cmp  al,'f'
    jne  dot_errb
got_gif:
    mov  gif,1
    mov  al,2
    jmp  phase2
;MAC check
check_mm:
    lodsb
    cmp al,'A'
    je  check_ma
    cmp al,'a'
    jne  dot_errb
check_ma:
    lodsb
    cmp  al,'C'
    je   got_mac
    cmp  al,'c'
    jne  dot_errb
got_mac:
    mov  mac,1
    mov  al,3
    jmp  phase2
;PCX check
check_pp:
    lodsb
    cmp al,'C'
    je  check_pc
    cmp al,'c'
    jne  dot_errb
check_pc:
    lodsb
    cmp  al,'X'
    je   got_pcx
    cmp  al,'C'
    je   got_pcx
    cmp  al,'x'
    je   got_pcx
    cmp  al,'c'
    jne  dot_errb
got_pcx:
    mov  al,4
    mov  pcx,1
phase2:
; got a type
    clc
    ret
open_input:
     mov  ah,3dh
     mov  al,0
     mov  cx,0
     int  21h
     jnc  good_copen
     ret
good_copen:
     mov  handle,ax
     ret
;
check_config proc near
; checks theconfiguration file
     lea  dx,cnfgfile
     call  open_input
     jnc   cgood_open
     ret
cgood_open:
; start parsing
c1:
     call  getcbyte
     jc    end_config
     cmp   al,13
     je    c1
     cmp   al,20h
     je    c1
     cmp   al,'A'
     je    getarc
     cmp   al,'D'
     je    getdir
bad_config:
     stc
     ret
end_config:
     cmp   arcer,0
     jne   ec1
     stc
     ret
ec1:
     cmp   tempdir,0
     je    bad_config
     clc
     ret
getdir:
     lea  di,tempdir
     jmp  ga1
getarc:
     lea  di,arcer
ga1:
     call  getcbyte
     jc    bad_config
     cmp  al,20h
     je   ga1
     cmp  al,'='
     je   ga2
     jmp  bad_config
ga2:
     call  getcbyte
     jc    bad_config
     cmp   al,20h
     je    ga2
     cmp   al,13
     je    bad_config
ga3:
     stosb
     call  getcbyte
     jc    end_config
     cmp   al,13
     jne   ga3
     jmp   c1
tempbyte db  0
getcbyte:
     mov   ah,3fh
     mov   bx,handle
     lea   dx,tempbyte
     mov   cx,1
     int   21h
     jnc   gcb1
     jmp   end_gcb
gcb1:
     cmp   ax,0
     je    end_gcb
     mov   al,tempbyte
     cmp   al,10
     je    getcbyte
     cmp   al,1ah
     je    end_gcb
     cmp   al,'a'
     jl    ret_gcb
     cmp   al,'z'
     jg    ret_gcb
     sub   al,32
ret_gcb:
     clc
     ret
end_gcb:
     mov   bx,handle
     mov  ah,3eh
     int  21h
     stc
     ret
check_config endp
cnfgfile db  65 dup(0)
check_command proc near
     mov   cl,byte ptr cs:[80h]
     mov   ch,0
     cmp   cx,3
     jg    ok_config1
bad_command:
     stc
     ret
ok_config1:
     mov   si,81h
     lea   di,cnfgfile
pc1:
     lodsb
     cmp   al,13
     je    bad_command
     cmp   al,20h
     jne   pc2
     loop  pc1
     jmp   bad_command
pc2:
     stosb
pc3:
     lodsb
     cmp   al,13
     je    bad_command
     cmp   al,20h
     je    pc4
     stosb
     loop  pc3
     jmp   bad_command
pc4:
     lodsb
     cmp   al,13
     je    bad_command
     cmp   al,20h
     jne   pc5
     loop  pc4
     jmp   bad_command
pc5a:
     lodsb
pc5:
; look for com port
     cmp   al,13
     je    bad_command
     cmp   al,20h
     je    bad_command
     cmp   al,'1'
     je    got_1
     cmp   al,'2'
     je    got_2
     loop  pc5a
     jmp   bad_command
got_1:
     mov  comport,0
     jmp   pc6
got_2:
     mov  comport,1
pc6:
; go for the file name
    lea   di,filename
pc7:
     lodsb
     cmp   al,13
     je    bad_command
     cmp   al,20h
     jne   pc8
     loop  pc7
     jmp   bad_command
pc8:
     stosb
pc9:
     lodsb
     cmp   al,13
     je    done_command
     cmp   al,20h
     je    done_command
     stosb
     loop  pc9
done_command:
     clc
     ret
reset_segs:
     push  ax
     mov   ax,cs
     mov   ds,ax
     mov   es,ax
     pop   ax
     ret
check_command endp
last_byte equ this byte
cseg     ends
     end     start
