;
;
cseg     segment para public 'CODE'
     assume   cs:cseg,ds:cseg,es:cseg
extrn last_byte:byte
;
; windows start here
;  menu structure is:
;    db height
;    db width
;    db x loc
;    db y loc
;    db color
;    db lines of data
;    db 0
;
error0  db 03,22,30,06,0f1h
        db  ' Field is in error',0
;
;
wait0   db 04,32,22,06,0f1h
        db  ' Installation will now begin ',13,10
        db  '  Press any key to continue ',0
;
errorsave dw 5*40 dup(0)
;
helpsave  dw 20*40 dup(0) ; for all helps

help0   db 06,55,10,15,07h
 db  '  Fill in the source diskette drive, the target disk',13,10
 db  '  and the target directory. Press F10 when you are ',13,10
 db  '  ready to begin the installation process.',13,10
 db  '          Press F1 if you need help.',13,10
 db  '      Press the ESC key if you wish to quit.',0

help1   db  7,40,20,13,70h
     db  ' Source diskette drive is the letter ',13,10
     db  ' of the drive that you will be using' ,13,10
     db  ' to read the installtion disks.',13,10
     db  ' Drive letters can be A, B, C, etc.',13,10
     db  '     press any key to continue',0
;
help2   db 06,40,20,15,70h
     db  ' Target Disk is the Hard disk where  ',13,10
     db  ' you will be installing the software',13,10
     db  ' This is usually disk letter "C".',13,10
     db  '     press any key to continue',0
;
;
help3   db 08,44,20,15,70h
     db  ' Target Directory is the DOS subdirectory',13,10
     db  ' where you would like the software to be',13,10
     db  ' installed. If the directory does not',13,10
     db  ' exist, it will be created for you.',13,10
     db  ' The directory must be a valid DOS name!',13,10
     db  '     press any key to continue',0
;
;
;
;
; these are the areas filled in by the user
;
head1     equ last_byte
head2     equ last_byte+64
tdir      equ last_byte+128
;
; fl types
fl1    db "D",50,0,14,1,071h,017h,' '
     dw  head1
fl2    db "D",50,0,14,2,071h,017h,' '
     dw  head2
fl3    db "D",16,0,05,06,041h,017h,' '
     dw  title1
title1    db "Source Diskette:    "
fl4    db "C",1,0,21,06,70h,07h,' '
     dw  sdisk
sdisk     db 'A '
fl5    db "D",16,0,05,08,41h,17h,' '
     dw  title2
title2    db "Target Disk:    "
fl6    db "C",1,0,21,08,70h,07h,' '
     dw  tdisk
tdisk  db 'C  '
fl7    db "D",16,0,05,10,41h,17h,' '
     dw  title3
title3    db "Target Directory "
fl8    db "C",40,0,21,10,70h,07h,'0'
     dw  tdir
;
; structure for fl stuff
;
enterline  dw  (end_tst-$-2)/2
     dw  fl1,fl2,fl3,fl4,fl5,fl6,fl7
     dw  fl8
end_tst equ this byte
clearscreen dw 1,cls
cls    db "D",1,0,16,1,070h,007h,' '
     dw  cls1
cls1      db ' '
;
;
eflag  db  0
;
extrn exit_phase:word
extrn forms:near,reset_segs:near
main     proc     near
imain:
public imain
;
;  ah has the attribute if we clear screen
;  al has the fl to get if we want to get just 1 fl
;  al has a 0ffh if we want to get all fls
;  al is 0 if we just want to display
;  bx has the fl to start phase cronology from
     lea     si,enterline
     mov     ax,1700h
     mov     bx,0
     call     forms
     lea   si,help0
     lea   di,helpsave
     call  do_window
     mov     bx,3   ; start with field 4
enter_loop:
     lea     si,enterline
     mov     ax,0ffh
     call     forms
     cmp     al,3bh     ; F1
     je     help_fields
     cmp     al,44h     ; F10
     je     check_fields
     cmp     ah,27
     je     exit_prog
     lea     si,enterline
     mov     ax,0ffh
     mov     bx,exit_phase
     jmp     enter_loop
exit_prog:
; clear the screen
     jmp   go_home
check_fields:
    jmp  check_fields0
help_fields:
extrn  do_window:near,undo_window:near

     mov     bx,exit_phase
     sub   bx,3
     jmp   cs:helps[bx]
helps dw do_help1,do_help2,do_help3
set_window:
     cmp   eflag,1
     jne   no_error_check
     push  si
     push  di
     mov   bx,exit_phase
     inc   bx
     shl   bx,1
     mov   si,word ptr enterline[bx]
     mov   al,byte ptr ds:[si]+4
     inc   al
     mov   error0+3,al
     mov   al,byte ptr ds:[si]+3
     mov   error0+2,al
     lea   si,error0
     lea   di,errorsave
     call  do_window
     pop   di
     pop   si
no_error_check:
     push  si
     push  di
     call  do_window
     mov   ah,0
     int   16h
     pop   di
     pop   si
     call  undo_window
     cmp   eflag,1
     jne   exit_help
     mov   eflag,0
     lea   si,error0
     lea   di,errorsave
     call  undo_window
exit_help:
     mov     bx,exit_phase
     jmp     enter_loop
do_help1:
     lea   si,help1
     lea   di,helpsave
     jmp   set_window
do_help2:
     lea   si,help2
     lea   di,helpsave
     jmp   set_window
do_help3:
     lea   si,help3
     lea   di,helpsave
     jmp   set_window
check_fields0:
; check each field
; check field 3, density first
     mov    al,byte ptr sdisk
     call   convert_upper
     jc     bad_c1
; validate disk exists?
     jmp    good_field1
bad_c1:
     mov    eflag,1
     mov    exit_phase,3
     jmp    do_help1
good_field1:
     mov    al,byte ptr tdisk
     call   convert_upper
     jc     bad_c2
; validate disk exists?
     jmp    good_field2
bad_c2:
     mov    eflag,1
     mov    exit_phase,5
     jmp    do_help2
good_field2:
; create the subdirectory on target disk
     jmp    good_field3
bad_c3:
; had a bad open
     mov    eflag,1
     mov    exit_phase,7
     jmp    do_help3
good_field3:
     lea   si,wait0
     lea   di,errorsave
     call  do_window
;
extrn  get_file:near
;    call   do_install
     mov    ah,0
     int    16h
     call   reset_segs
go_home:
     lea     si,clearscreen
     mov     ax,0700h
     mov     bx,0
     call    forms
     ret
convert_upper:
; makes al upper case
     cmp   al,'A'
     jl    bad_al
     cmp   al,'z'
     jg    bad_al
     cmp   al,'Z'
     jle   ok_al
     cmp   al,'a'
     jl   bad_al
     sub  al,20h
ok_al:
     clc
     ret
bad_al:
     stc
     ret
;
main  endp
cseg     ends
     end
