; VKPAL.ASM sets screen palette
;
;
dseg        SEGMENT PUBLIC 'DATA'
;
; *********  GRAY 16 SHADES MAP ***********************8
;
g161 macro x
db  48 dup(x)
endm
gray_map_16 equ this byte
g161 0
g161 4
g161 8
g161 12
g161 16
g161 20
g161 24
g161 28
g161 32
g161 36
g161 40
g161 44
g161 48
g161 52
g161 56
g161 60
g161 64
;
; *********  GRAY 64 SHADES MAP ***********************8
;
; g641 does 32 colors starting at x
g641 macro x
db  12 dup(x)
db  12 dup(x+1)
db  12 dup(x+2)
db  12 dup(x+3)
db  12 dup(x+4)
db  12 dup(x+5)
db  12 dup(x+6)
db  12 dup(x+7)
endm
gray_map_64 equ this byte
g641 0
g641 8
g641 16
g641 24
g641 32
g641 40
g641 48
g641 56
g641 64
;
; *********  GRAY 256 SHADES MAP ***********************8
;       Used for gray 256 and GRB
;
g2561 macro x,y
db  x,y,0     ;0
db  x,y,2     ;2.3
db  x,y,5     ;4.6
db  x,y,7     ;6.9
db  x,y,9     ;9.2
db  x,y,11    ;11.5
db  x,y,14    ;13.8
db  x,y,16    ;16.1
db  x,y,18    ;18.4
db  x,y,21    ;20.7
db  x,y,23    ;22.8
db  x,y,25    ;25.1
db  x,y,27    ;27.4
db  x,y,30    ;29.7
db  x,y,32    ;32.0
db  x,y,34    ;34.3
db  x,y,37    ;36.6
db  x,y,39    ;38.9
db  x,y,41    ;41.2
db  x,y,42    ;43.5
db  x,y,46    ;45.6
db  x,y,48    ;47.9
db  x,y,50    ;50.2
db  x,y,52    ;52.5
db  x,y,55    ;54.8
db  x,y,57    ;57.1
db  x,y,59    ;59.4
db  x,y,62    ;61.7
endm
g2562 macro z
g2561 z,0     ;
g2561 z,21    ;
g2561 z,42    ;
g2561 z,63    ;
endm
gray_map_256 equ this byte
g2562  0
g2562  63
;
;
curr_map_256 equ this byte
public curr_map_256
; this is the current map
   db 3*256 dup(0)
;
map_sw  db 0
;
dseg        ENDS
cseg    segment PUBLIC 'CODE'
        assume     CS:cseg,DS:dseg,ES:dseg
EXTRN       reset_segs:near
;
;
set_maps proc near
;
;
reset_map:
public reset_map
   call  reset_segs
   add  map_sw,1
   cmp  map_sw,2
   jge  gray256
   jmp  curr256
gray256:
   mov  map_sw,0
public gray256
            call  reset_segs
            mov   ah,10h
            mov   al,12h
            mov   bx,0
            mov   cx,256
            lea   dx,gray_map_256
            int   10h
            mov   ah,10h
            mov   al,1bh
            mov   bx,0
            mov   cx,256
            lea   dx,gray_map_64
            int   10h
            clc
            ret
;
curr256:
public curr256
            call  reset_segs
;           mov   ah,10h
;           mov   al,12h
;           mov   bx,0
;           mov   cx,256
;           lea   dx,curr_map_256
;           int   10h
            mov   ah,10h
            mov   al,12h
            mov   bx,0
            mov   cx,256
            lea   dx,curr_map_256
            int   10h
            clc
            ret
;
gray64:
public gray64
            call  reset_segs
            mov   ah,10h
            mov   al,12h
            mov   bx,0
            mov   cx,256
            lea   dx,gray_map_64
            int   10h
            clc
            ret
;
gray16:
public gray16
            call  reset_segs
            mov   ah,10h
            mov   al,12h
            mov   bx,0
            mov   cx,256
            lea   dx,gray_map_16
            int   10h
            clc
            ret
set_maps    ENDP
cseg            ends
            END
