print macro string
push cx
push di
lea  di,string
mov  dx,di
mov  cx,di
cld
mov  al,0
repne scasb
mov  cx,dx
sub  cx,di
neg  cx
dec  cx
mov  ah,40h
mov  bx,device
int 21h
pop  di
pop  cx
endm
read macro string
lea  dx,string
mov ah,10
int 21h
endm
;
cseg      segment para public 'CODE'
          assume   cs:cseg,ds:cseg,ss:cseg,es:cseg
          org   100h
start: jmp  main
hi db 13,10,"Little Base",13,10
   db "Copyright 1988 by Keith P. Graham",13,10,0
bye db 13,10,"Thanks for using LBASE",13,10
crlf db 13,10,0
comline db 80,0,82 dup(0)
uline db 128 dup(0)
dot  db 13,10,'. ',0
device dw 1
ten   db 10
selected dw 0
erc db 0
parens db 0
pcount dw 0
p struc
ptype db 0
ploc  dw 0
plen  db 0
p ends
parsels equ this byte
   db  80 dup(0,0,0,0)
tstring db 256 dup(0)
;
; commands
commands equ this byte
 db 0,"QUIT",0,1
 db 0,"USE",0,2
 db 0,"SELECT",0,3
 db 0,"DISPLAY",0,4
 db 0,"LIST",0,5
 db 0,"?",0,6
 db 0,0  ; end of commands
comlen equ $-commands
errors dw e1,e2,e3,e4,e5
        dw e6
e1 db 13,10,'Command not recognized',13,10,0
e2 db 13,10,'Unbalanced Quotes',13,10,0
e3 db 13,10,'Unbalanced parentheses',13,10,0
e4 db 13,10,'What the hell is that?',13,10,0
e5 db 13,10,'File not found',13,10,0
e6 db 13,10,'SELECT must be from 1 to 9',13,10,0
csec    proc near
; commands live here
select:
; select a database number
   mov  erc,6
; select number must be in the second parsed area
   lea  bx,parsels
;  int 3
   add  bx,4 ; second
   cmp  ptype[bx],'N'
   je   sel1
sel_ret:
   ret
sel1:
   mov  cl,plen[bx]
   mov  ch,0
   mov  si,ploc[bx]
   call make_int  ; converts the guy to bin in DX.AX
   cmp  ax,1
   jl   sel_ret
   cmp  ax,10
   jg   sel_ret
   mov  erc,0
   mov  selected,ax
   ret
use:
; this is the use a database guy
; the second guy must have a name to use
   ret
quit:
    print bye
    int   20h
nyi:
    print e4
    ret
csec    endp
make_int proc near
; this converts the si guy for a length of cx into dx.ax
; works for positive integers
;
   int  3
   push  bx
   cld
   mov   bx,0
   mov   dx,0
   cmp   cx,4
   jle   mb2
   push  cx
   mov   cx,4
mb1:
; this puts the high 4 digits into dx
   lodsb
   cmp   al,'.'
   je    mb4
   xchg  ax,dx
   mul   ten
   and   dx,0fh
   add   dx,ax
   loop  mb1
   pop   cx
   sub   cx,0
mb2:
; this puts the low foue digits into bx
   lodsb
   cmp   al,'.'
   je    mb3
   xchg  ax,bx
   mul   ten
   and   bx,0fh
   add   bx,ax
   loop  mb2
mb3:
   mov   ax,bx
   jmp   mb5
mb4:
   pop   cx
   mov   ax,dx
   mov   dx,0
mb5:
; dx has the high 9999 and ax has the low 9999
   mov   bx,ax
   mov   cx,10000
   mov   ax,dx
   mul   cx
   add   ax,bx
   adc   dx,0
   pop   bx
   ret
make_INT endp
commander dw quit,use,select,nyi,nyi,nyi,nyi,nyi,nyi
main      proc     near
; this is the procedure
        print hi
top_loop:
        mov  erc,0
        mov  parens,0
        print dot
        read  comline
        cmp   comline+1,0
        jle   top_loop
        call  parse
        cmp   erc,0
        jne   perr
        call  action
        cmp   erc,0
        jne   perr
        jmp   top_loop
perr:
        mov   bl,erc
        mov   bh,0
        dec   bx
        shl   bx,1
        mov   bx,errors[bx]
        print ds:[bx]
        jmp   top_loop
parse:
    mov  pcount,0
    call fix
    call parsel
    cmp  erc,0
    jne  eparse
eparse:
    ret
action:
   mov  erc,1
   dec  pcount
   cmp tstring,"!"
   je bang
; check for a command
   lea  bx,parsels
   cmp  ptype[bx],'C'
   je   check_command
   ret
check_command:
   mov  dl,plen[bx]
   mov  dh,0
   mov  di,ploc[bx]
   lea  si,commands
cloop:
   lodsb
   cmp  al,0
   je   cl1
   ret
cl1:
   cmp  byte ptr ds:[si],0
   jne  cl2
   ret
cl2:
   mov  cx,dx   ; length of parse
cl3:
   lodsb
   cmp al,0
   je  got_command
   cmp al,byte ptr ds:[di]
   jne  not_command
   inc  di
   loop cl3
; partial match, len of parse must be 4 to count on a partial match
   inc  si
   cmp byte ptr ds:[si],0
   cmp  dx,4
   jge  cl3a
   jmp  not_command
cl3a:
; partial match on 4 items, still need si
   cmp byte ptr ds:[si],0
   je  cl3b
   inc  si
   jmp cl3a
cl3b:
; point to a zero
   inc si
   jmp got_command
not_command:
; does no match run out si until a zero is hit
   cmp byte ptr ds:[si],0
   je  n_command
   inc  si
   jmp not_command
n_command:
   inc  si
   inc  si
   inc  si
   mov  di,ploc[bx]
; start again on next command
   jmp  cl1
got_command:
; the command is found
   lodsb  ; command number
   mov  ah,0
   mov  si,ax
   dec  si
   shl  si,1
   mov  erc,0
   jmp commander[si]
;
;
bang:
   print crlf
   lea  si,parsels
   mov  cx,pcount
bang2:
   push  cx
   mov  dx,ploc[si]
   mov  cl,plen[si]
   mov  ch,0
   mov  ah,40h
   mov  bx,1
   int  21h
   print crlf
   add  si,4
   pop  cx
   loop bang2
   ret
spchars db '()<>=.*+-/'
  splen = $-spchars
parsel:
; breaks the parsed gues into chunks and type checks them
    lea  di,tstring
    lea   bx,parsels
    lea   si,uline
; this is the setup for parsels
par1:
; here we are starting a new parse
    lodsb
par2:
    cmp  al,20h
    je  par1
    inc  pcount
    mov  plen[bx],1
; new parse
; check for special character
    cmp   al,0
    jne   not_end
par_end:
    ret
not_end:
    push  di
    lea   di,spchars
    mov   cx,splen
    cld
repne  scasb
    pop  di
    jne  not_sp
    sub  cx,splen
    neg  cx
    dec  cx
; got a special character
    mov  ptype[bx],'S'
    mov  ploc[bx],cx
    add  bx,4
    jmp  par1
not_sp:
; not a special character
; check for quote
    cmp  al,'"'
    je   pq1
    cmp  al,"'"
    je   pq1
;   is it numeric?
    cmp  al,'0'
    jl   not_num
    cmp  al,'9'
    jg   not_num
; its numeric
    mov  ptype[bx],'N'
    mov  ploc[bx],di
    call get_num
    add  bx,4
    jmp  par2   ; al has the next character
pq1:
; this has a string
    mov  ptype[bx],'Q'
    mov  ploc[bx],di
    mov  dl,al
pq2:
    lodsb
    cmp  al,0
    je  pq4
    cmp  al,dl
    je  pq3
    stosb
    inc  plen[bx]
    jmp pq2
pq3:
    lodsb
pq4:
    add  bx,4
    jmp  par2   ; al has the next character
;
;
;
not_num:
; not character
    mov  ptype[bx],'C'
    mov  ploc[bx],di
    call get_cs
    add  bx,4
    jmp  par2   ; al has the next character
get_cs:
; gets character strings
     stosb
     lodsb
; check for sp char
    cmp   al,0
    je    end_cs
    cmp   al,20h
    je    end_cs
    push  di
    lea   di,spchars
    mov   cx,splen
    cld
repne  scasb
    pop  di
    je   end_cs
    inc  plen[bx]
     jmp  get_cs
end_cs:
     ret
get_num:
; gets numbers
     stosb
     lodsb
     cmp  al,'0'
     jl  end_ns
     cmp  al,'9'
     jg   end_ns
by_num:
    inc  plen[bx]
     jmp  get_num
end_ns:
     cmp  al,'.'
     je   by_num
     ret
fix:
; fixes up the command line by trimming and other stuff
          mov  erc,255
          mov  parens,0
;
          lea  di,uline ; intermediate area
          mov  al,0
          cld
          mov  cx,128
rep stosb
          lea  si,comline+2
          lea  di,uline ; intermediate area
          mov  cl,comline+1
          mov  ch,0
; start out by eliminating leading spaces
fix1:
          cld
          lodsb
          call upper
          cmp  al,13
          jne  fix2
fixret:
          cmp  parens,0
          jne  p_err
          ret
p_err:
          mov  erc,3
          ret
fix2:
; trim leading spaces
          cmp  al,13
          je   fixret
          cmp  al,20h
          jne  fix3
          lodsb
          call upper
          loop fix2
          jmp  fixret
fix3:
; have a byte at the beginning of a string (not a space)
          mov  erc,0
          cmp  al,'"' ; quote
          je   fix10
          cmp  al,"'" ; quote
          je   fix10
          stosb
fix4:
          lodsb
          call upper
          cmp  al,13
          je  fixret
          cmp  al,20h
          je   fix5
          cmp  al,'"' ; quote
          je   fix4a
          cmp  al,"'" ; quote
          je   fix4a
          stosb
          loop fix4
          jmp  fixret
fix4a:
          mov  erc,2
          jmp  fixret
fix5:
; found the next space
          stosb
          loop   fix1
          jmp  fixret
fix10:
; a quoted string has to be transfered
        stosb
        mov  dl,al
fix11:
        lodsb
        cmp  al,13
        je   bad_quote
        stosb
        cmp  al,dl
        je  end_quote
        loop fix11
bad_quote:
     mov  erc,2
          jmp  fixret
end_quote:
        mov al,20h
        stosb
        jmp fix1
upper: ; converts al to upper case
     cmp  al,'a'
     jl  uret
     cmp   al,'z'
     jg    uret
     sub   al,20h
uret:
     cmp   al,')' ; left paren
     je    lparen
     cmp   al,'(' ; right paren
     je    rparen
     ret
lparen:
     dec   parens
     ret
rparen:
     inc   parens
     ret
main      endp
cseg      ends
          end      start
