;
; this is a skeleton for passthrough  or resident programs
;
; when compiled as a pass through program it will use a little over
; 5K of system memory. When compiled as resident program it takes
; about 1.5k. When you add your own routines an work areas this
; will increase.
;
passthru = 1  ; 1 is true which means MASM will create the passthroug
              ; version.
; if you are making a passthroug version then rou are not making
; a resident version. And if you are not making a passthrough then
; you are making a resident.
;
print macro string
    lea dx,string
    mov  ah,9
    int  21h
    endm
if passthru
   resident = 0
else
   resident = 1
endif
CSEG        SEGMENT PARA PUBLIC 'CODE'
        ASSUME CS:CSEG,DS:CSEG,SS:CSEG,ES:CSEG
        ORG        100H
ENTPT:        JMP        setpass
; this area is used by the resident and passthrough versions
;
stack   dw   256  dup(0)
int21      dd  0
int21ip   equ word ptr int21
int21cs   equ word ptr int21 + 2
savesp   dw  0
savess   dw  0
savespl  dw  0
savessl  dw  0
mess0    db  'NETWKS version 1.00',13,10
         db  'Copyright 1987 by Keith P. Graham',13,10,10
         db  'NETWKS network file share service installing....',13,10
         db  '$'
;
; this data is used by the passthru program only
;
if passthru
mess1    db  13,10,'NETWKS network file share service complete',13,10,'$'
command_line db 129 dup(0)
; parmblock is used for the parmeters for the execute
parmblock  dw  0  ; this is the parmblock for execute
           dw command_line
tailds     dw  0
           dw 5ch ; fcb in psp
fcb1       dw  0
           dw 6ch ; fcb in psp
fcb2       dw  0
endif
START        PROC        far
dos:
; we are entering here due to a key being struck
; first check the dos area to see if the CTRL and ALT are ppasssed
;
; first call the dos interrupt so that it can handle the
; dos call we are interested in 2 calls, open and read
;
        cmp    ah,45h  ; close
        jne    no_45
        pushf
        int    3
        call  cs:int21
        push  ax
        pushf
        push  cs
        lea   ax,do_iret
        push  ax
        iret
no_45:
        cmp    ah,46h  ; close
        jne    no_46
        pushf
        int    3
        call  cs:int21
        push  ax
        pushf
        push  cs
        lea   ax,do_iret
        push  ax
        iret
no_46:
        cmp    ah,3eh  ; close
        jne    no_3e
        pushf
        int    3
        call  cs:int21
        push  ax
        pushf
        push  cs
        lea   ax,do_iret
        push  ax
        iret
no_3e:
        cmp    ah,3dh  ; open
        jne    no_3d
        pushf
        int    3
        call  cs:int21
        push  ax
        pushf
        push  cs
        lea   ax,do_iret
        push  ax
        iret
no_3d:
        jmp   cs:int21
do_iret:
        pop  ax
        ret 2
START        ENDP
setpass  proc  near
; set up a local stack
        lea  sp,stack+510
        print mess0
;
; redirect interrupts here
;
        push  es
        mov   ax,3521h
        int   21h
        mov   int21cs,es
        mov   int21ip,bx
        pop   es
        mov   ah,25h
        mov   al,21h
        lea   dx,dos
        int   21h
if  passthru
;
;  prepare for the exec function
; shrink memory
   lea   bx,last_byte    ; last byte of program
   add   bx,15           ; trick to round up
   mov   cl,4
   shr   bx,cl           ; divide by 16 to get number of 16 byte blocks
   mov   ah,4ah          ; shrink
   int   21h
; create the commandline
;
; the command line has to start with /C and then the command
; and then end with a carriage return. It must have a byte at
; the front saying how long it is
   cld
   lea   di,command_line+1
   mov   al,'/'
   stosb
   mov   al,'C'
   stosb
   mov   al,' '
   stosb
; now copy the real command line in
   mov   si,81h
   mov   cl,byte ptr ds:[80h]
   mov   ch,0
   push  cx
   cmp   cx,0
   je    no_move
   cld
rep movsb
no_move:
   pop   cx
   add   cx,3
   mov   command_line,cl
; set up the control block with segment information
   mov    tailds,ds
   mov    fcb1,ds
   mov    fcb2,ds
;
; find the comspec
;
   mov    es,word ptr  ds:[2ch]
   mov     di,0
   mov     cx,255
env_loop:
   cld
   mov   al,'='
repne   scasb
; if there is no comspec, there is something wrong with the system
   cmp   word ptr es:[di-3],'CE'
   jne   env_loop
   cmp   word ptr es:[di-5],'PS'
   jne   env_loop
   cmp   word ptr es:[di-7],'MO'
   jne   env_loop
   cmp   byte ptr es:[di-8],'C'
   jne   env_loop
; got the comspec
;
; save the stack
;
   mov   savess,ss
   mov   savesp,sp
;
; set up the segment registers
;
; the comspec segment is in ES and should be in DS
;
   push  es
   pop   ds
   push  cs
   pop   es
   mov   dx,di
   lea   bx,parmblock
   mov   al,0
   mov   ah,4bh
; execute the thing
   int   21h
; here is where we return
   mov   ss,cs:savess
   mov   sp,cs:savesp
   mov   ax,cs
   mov   ds,ax
   mov   es,ax
; say that we did it
   print   mess1
;
; now reset the interrupts so we can leave
;
        push  ds
        lds   dx,int21
        mov   ah,25h
        mov   al,21h
        int   21h
        pop   ds
        int   20h
endif
if resident
        lea   dx,setpass  ; don't make the install portion resident
        int 27h
endif
setpass  endp
last_byte equ this byte
CSEG        ENDS
        END        ENTPT
