dseg     segment para public 'data'
;
;
;
; windows start here
;  menu structure is:
;    db x loc
;    db y loc
;    db color
;    dw  savearea
;    db lines of data
;    db 0
;
error0  db 30,06,0f1h
        dw  errorsave
        db  ' Field is in error ',10,0
;
;
;
errorsave dw 6*42 dup(0)
;
helpsave  dw 20*42 dup(0) ; for all helps

public error0,errorsave,helpsave
help0   db 10,15,07h
     dw  helpsave
 db  ' help0',10
     db  '     press any key to continue ',10,0
;
help1   db 20,13,70h
     dw  helpsave
     db  ' help1',10
     db  '     press any key to continue ',10,0
;
help2   db 20,15,70h
     dw  helpsave
     db  ' help2',10
     db  '     press any key to continue ',10,0
;
;
;
;
; fl types
fl1    db "D",35,0,16,1,071h,017h,' '
     dw  head1
head1     db '     Mariner, Mandelbrot Explorer       '
fl2    db "D",44,0,17,2,071h,017h,' '
     dw  head2
head2     db "Vers 1.00 Copyright 1989 by Keith P. Graham   "
fl3    db "D",19,0,01,06,041h,017h,' '
     dw  title1
title1    db "Upper X Location:  "
fl4    db "N",12,0,20,06,70h,07h,' '
     dw  pmaxin
pmaxin  db 15 dup(20h)
fl5    db "D",19,0,01,08,41h,17h,' '
     dw  title2
title2    db "Upper Y Location:  "
fl6    db "N",12,0,20,08,70h,07h,' '
     dw  qmaxin
qmaxin    db 15 dup(20h)
fl7    db "D",19,0,01,10,041h,017h,' '
     dw  title3
title3    db "Lower X Location:  "
fl8    db "N",12,0,20,10,70h,07h,' '
     dw  pminin
pminin  db 15 dup(20h)
fl9    db "D",19,0,01,12,41h,17h,' '
     dw  title4
title4    db "Lower Y Location:  "
fl10    db "N",12,0,20,12,70h,07h,' '
     dw  qminin
qminin    db 15 dup(20h)
;
; structure for fl stuff
;
enterline  dw  (end_tst-$-2)/2
     dw  fl1,fl2,fl3,fl4,fl5,fl6,fl7,fl8,fl9,fl10
end_tst equ this byte
clearscreen dw 1,cls
cls    db "D",1,0,16,1,070h,007h,' '
     dw  cls1
cls1      db ' '
;
;
eflag  db  0
;
;
;
;
extrn exit_phase:word
dseg ends
cseg     segment para public 'CODE'
     assume   cs:cseg,ds:dseg,es:dseg
extrn forms:near,reset_segs:near
start     proc     near
main:
public main
;
;  ah has the attribute if we clear screen
;  al has the fl to get if we want to get just 1 fl
;  al has a 0ffh if we want to get all fls
;  al is 0 if we just want to display
;  bx has the fl to start phase cronology from
     call   reset_segs
; clean out the two file names
     lea     si,enterline
     mov     ax,1700h
     mov     bx,0
     call     forms
     lea   si,help0
     lea   di,helpsave
     call  do_window
     mov     bx,3   ; start with field 4
enter_loop:
     lea     si,enterline
     mov     ax,0ffh
     call     forms
     cmp     al,3bh     ; F1
     je     help_fields
     cmp     al,44h     ; F10
     je     check_fields
     cmp     ah,27
     je     exit_prog
     lea     si,enterline
     mov     ax,0ffh
     mov     bx,exit_phase
     jmp     enter_loop
exit_prog:
; clear the screen
     jmp   go_home
check_fields:
    jmp  check_fields0
help_fields:
extrn  do_window:near,undo_window:near

     mov     bx,exit_phase
     sub   bx,3
     jmp   cs:helps[bx]
helps dw do_help1,do_help2
set_window:
     cmp   eflag,1
     jne   no_error_check
     push  si
     push  di
     mov   bx,exit_phase
     inc   bx
     shl   bx,1
     mov   si,word ptr enterline[bx]
     mov   al,byte ptr ds:[si]+4
     inc   al
     mov   error0+1,al
     mov   al,byte ptr ds:[si]+3
     mov   error0+0,al
     lea   si,error0
     lea   di,errorsave
     call  do_window
     pop   di
     pop   si
no_error_check:
     push  si
     push  di
     call  do_window
     mov   ah,0
     int   16h
     pop   di
     pop   si
     call  undo_window
     cmp   eflag,1
     jne   exit_help
     mov   eflag,0
     lea   si,error0
     lea   di,errorsave
     call  undo_window
exit_help:
     mov     bx,exit_phase
     jmp     enter_loop
do_help1:
     lea   si,help1
     lea   di,helpsave
     jmp   set_window
do_help2:
     lea   si,help2
     lea   di,helpsave
     jmp   set_window
check_fields0:
; check each field
; check field 3, density first
;    cmp    inname,' '
;    je     bad_c1
     jmp    good_field1
bad_c1:
     mov    eflag,1
     mov    exit_phase,3
     jmp    do_help1
good_field1:
;    cmp    outname,' '
;    je     bad_c2
     jmp    good_field2
bad_c2:
     mov    eflag,1
     mov    exit_phase,5
     jmp    do_help2
good_field2:
; here we have to open the input file
;
;
;
go_home:
     cmp     ah,27
     je      leave_us
     lea     si,clearscreen
     mov     ax,0700h
     mov     bx,0
     call    forms
;extrn extrn:mandelbrot
;     call    madelbrot
     jmp     main
leave_us:
     lea     si,clearscreen
     mov     ax,0700h
     mov     bx,0
     call    forms
     ret
create_file:
;    mov   bx,handleo
;    cmp   bx,0
;    je    do_openo
;    mov    ah,3eh
;    int    21h
;o_openo:
;    mov   cx,0
;    mov   ax,3c00h
;    int   21h
;    jnc   good_create
;    stc
;    ret
;ood_create:
;    mov   handleo,ax
;    clc
;    ret
;
;pen_input:
; first check, the file might be open
;    mov   bx,handlei
;    cmp   bx,0
;    je    do_openi
;    mov    ah,3eh
;    int    21h
;o_openi:
; open a file for i/o
;    mov   cx,0
;    mov   ax,3d00h
;    int   21h
;    jnc   good_open_in
;    stc
;    ret
;ood_open_in:
;    mov   handlei,ax
;    mov   bx,ax
;   mov   ax,4200h
;   mov   dx,0
;   mov   cx,0
;   int   21h
;    clc
;    ret
;
start  endp
cseg     ends
     end
