print macro string
     lea   dx,string
     mov   ah,9
     int   21h
     endm
input macro string
     lea   dx,string
     mov   ah,10
     int   21h
     endm
clear		equ	256		;Clear code
eof		equ	257		;End of file marker
first_free	equ	258		;First free code
maxmax		equ	4096		;Max code + 1
maxbits         equ     12


;Hash table entry
hash_rec	struc
first	dw	?			; First entry with this value
next	dw	?			; Next entry along chain
char	db	?			; Suffix char
hash_rec	ends


;Start writing code
cseg	segment
	assume	cs:cseg,ds:cseg,es:cseg
        org  100h
entry:  jmp  start
input_prompt	db	'Input file: $'
output_prompt	db	'Output file: $'
input_file	db	80,0,80 dup (?)
output_file	db	80,0,80 dup (?)
crlf		db	13,10,'$'
buffer1   dw 0
buffer2   dw 0
istack     dw 0
input_handle	dw	?
output_handle	dw	?

hash_seg	dw	?
prefix_code	dw	?
free_code	dw	?
max_code	dw	?
nbits		dw	?
k		db	?


bit_offset	dw	?
input_offset	dw	0
input_size	dw	0

start	proc	near
        call    shrink
        jnc     good_shrink1
        int     20h
good_shrink1:
	print	input_prompt		;Get input file name
	input	input_file
	print	crlf
	print	output_prompt		;And output
	input	output_file
	print	crlf
	mov	al,input_file+1		;Terminate file names with nulls
	xor	ah,ah
	mov	si,ax
	mov	input_file+2[si],0
	mov	al,output_file+1
	mov	si,ax
 	mov	output_file+2[si],0
        lea     dx,input_file+2
        mov     ax,3d00h
        mov     cx,0
        int     21h
        jc       bad_open
	mov	input_handle,ax
        lea     dx,output_file+2
        mov     ax,3c00h
        mov     cx,0
        int     21h
        jc       bad_open
	mov	output_handle,ax
	call	compress		;Compress file
	mov    bx,input_handle
        mov    ah,3eh
        int    21h
	mov    bx,output_handle
        mov    ah,3eh
        int    21h
	int   20h				;Done
bad_open:
        int  20h
start	endp
compress	proc	near
l1:	call	init_table		;Initialize the table and some vars
	mov	ax,clear		;Write a clear code
	call	write_code
	call	read_char		;Read first char
l4:	xor	ah,ah			;Turn char into code
l4a:	mov	prefix_code,ax		;Set prefix code
	call	read_char		;Read next char
	jc	l17			;Carry means eof
	mov	k,al			;Save char in k
	mov	bx,prefix_code		;Get prefix code
	call	lookup_code		;See if this pair in table
	jnc	l4a			;nc means yes, new code in ax
	call	add_code		;Add pair to table
	push	bx			;Save new code
	mov	ax,prefix_code		;Write old prefix code
	call	write_code
	pop	bx
	mov	al,k			;Get last char
	cmp	bx,max_code		;Exceed code size?
	jl	l4			;less means no
	cmp	nbits,maxbits		;Currently less than 12 bits?
	jl	l14			;yes
	mov	ax,clear		;Write a clear code
	call	write_code
	call	init_table		;Reinit table
	mov	al,k			;get last char
	jmp	l4			;Start over
l14:	inc	nbits			;Increase number of bits
	shl	max_code,1		;Double max code size
	jmp	l4			;Get next char
l17:	mov	ax,prefix_code		;Write last code
	call	write_code
	mov	ax,eof			;Write eof code
	call	write_code
	mov	ax,bit_offset		;Make sure buffer is flushed to file
  	cmp	ax,0
	je	l18
  	mov	cx,ax			;convert bits to bytes
     	call	flush
l18:	ret
compress	endp

init_table	proc	near
	mov	nbits,9			;Set code size to 9
	mov	max_code,512		;Set max code to 512
	push	es			;Save seg reg
	mov	es,hash_seg		;Address hash table
	mov	ax,-1			;Unused flag
	mov	cx,640			;Clear first 256 entries
	mov	di,0
rep	stosw				;Clear it out
	pop	es			;Restore seg reg
	mov	free_code,first_free	;Set next code to use
	ret				;done
init_table	endp

write_code	proc	near
        push    si
        push    di
        mov     di,cs:bit_offset
        cld
        push    es
        mov     es,cs:buffer2
        stosw
        pop     es
        pop     di
        pop     si
        inc     bit_offset
        inc     bit_offset
        cmp     bit_offset,1ffeh
        jg      do_flush
        clc
        ret
do_flush:
        mov     cx,bit_offset
        mov     ax,cx
	call	flush			;Write the buffer
        mov     bit_offset,0
        ret
write_code	endp

flush		proc	near
	push	ax			;Save all registers
	push	bx			;AX contains number of bytes to write
	push	cx
	push	dx
        mov     cx,ax
        mov     bx,output_handle
        mov     ah,40h
        mov     dx,0
        push    ds
        mov     ds,cs:buffer2
        int     21h
        pop     ds
        mov     al,'W'
        mov     ah,14
        int     10h
	pop	dx
	pop	cx
	pop	bx
	pop	ax
	ret
flush		endp

read_char	proc	near
	mov	di,input_offset		;Anything left in buffer?
	cmp	di,input_size
	jl	rd1			;less means yes
        mov     cx,2000h
        mov     bx,cs:input_handle
        mov     ah,3fh
        mov     dx,0
        push    ds
        mov     ds,cs:buffer1
        int     21h
        pop     ds
        push    ax
        mov     al,'R'
        mov     ah,14
        int     10h
        pop     ax
	cmp	ax,0			;Anything left?
	je	rd2			;equal means no, finished
	mov	input_size,ax		;Save bytes read
	mov	input_offset,0		;Point to beginning of buffer
	mov	di,0
rd1:	mov	si,di
        push    ds
        mov     ds,cs:buffer1
	lodsb				;Read it in
        pop     ds
	inc	input_offset		;Adjust pointer
	clc				;Success
	ret
rd2:	stc				;Nothing left
	ret
read_char	endp


lookup_code	proc	near
	push	ds			;Save seg reg
	mov	ds,hash_seg		;point to hash table
	call	index			;convert code to address
	mov	di,0			;flag
	cmp	[si].first,-1		;Has this code been used?
	je	gc4			;equal means no
	inc	di			;set flag
	mov	bx,[si].first		;Get first entry
gc2:	call	index			;convert code to address
	cmp	[si].char,al		;is char the same?
	jne	gc3			;ne means no
	clc				;success
	mov	ax,bx			;put found code in ax
	pop	ds			;restore seg reg
	ret				;done
gc3:	cmp	[si].next,-1		;More left with this prefix?
	je	gc4			;equal means no
	mov	bx,[si].next		;get next code
	jmp	gc2			;try again
gc4:	stc				;not found
	pop	ds			;restore seg reg
	ret				;done
lookup_code	endp

index		proc	near
	mov	si,bx			;si = bx * 5 (5 byte hash entries)
	shl	si,1			;si = bx * 2 * 2 + bx
	shl	si,1
	add	si,bx
	ret
index		endp

add_code	proc	near
	mov	bx,free_code		;Get code to use
	push	ds			;point to hash table
	mov	ds,hash_seg
	cmp	di,0			;First use of this prefix?
	je	ac1			;equal means yes
	mov	[si].next,bx		;point last use to new entry
	jmp	short ac2
ac1:	mov	[si].first,bx		;Point first use to new entry
ac2:	cmp	bx,maxmax		;Have we reached code limit?
	je	ac3			;equal means yes, just return
	call	index			;get address of new entry
	mov	[si].first,-1		;initialize pointers
	mov	[si].next,-1
	mov	[si].char,al		;save suffix char
	inc	es:free_code		;adjust next code
ac3:	pop	ds			;restore seg reg
	ret
add_code	endp

        last_byte db 16 dup(0)
error2  db 'Error allocating memory',13,10,'$'
shrink:
; allocates memory
; shrink
;
     mov  ah,4ah
     lea  bx,last_byte
     add  bx,15
     shr  bx,1
     shr  bx,1
     shr  bx,1
     shr  bx,1
     int  21h
     jnc  good_shrink
bad_mem:
     print error2
     stc
     ret
good_shrink:
; allocate 64k buffer for file access
     mov  ah,48h
     mov  bx,200h ; 16k
     int  21h
     jc   bad_mem
     mov  buffer1,ax
     mov  ah,48h
     mov  bx,400h ; 16k
     int  21h
     jc   bad_mem
     mov  buffer2,ax
; allocate the hash
     mov  ah,48h
     mov  bx,1480 ; 20k
     int  21h
     jc   bad_mem
     mov  hash_seg,ax
; allocate the stack
     mov  ah,48h
     mov  bx,200h ; 8k
     int  21h
     jc   bad_mem
     mov  istack,ax
     pop  bx
     mov  ss,ax
     mov  sp,1ffch
     push bx
     clc
     ret
cseg	ends

	end	entry
