;
;
passthru = 1  ; 1 is true which means MASM will create the passthroug
              ; version.
; if you are making a passthroug version then rou are not making
; a resident version. And if you are not making a passthrough then
; you are making a resident.
;
if passthru
   resident = 0
else
   resident = 1
endif
CSEG        SEGMENT PARA PUBLIC 'CODE'
        ASSUME CS:CSEG,DS:CSEG,SS:CSEG,ES:CSEG
        ORG        100H
ENTPT:        JMP        setpass
; this area is used by the resident and passthrough versions
;
stack   dw   256  dup(0)
savesp   dw  0
savess   dw  0
savespl  dw  0
savessl  dw  0
semaphore db  0
mode  dw 0b800h
cursor dw 0
cursmode dw 0
bhpage db 0
screen  dw 25*80 dup(0)
;
; this data is used by the passthru program only
;
if passthru
command_line db 129 dup(0)
; parmblock is used for the parmeters for the execute
parmblock  dw  0  ; this is the parmblock for execute
           dw command_line
tailds     dw  0
           dw 5ch ; fcb in psp
fcb1       dw  0
           dw 6ch ; fcb in psp
fcb2       dw  0
endif
getcurs   proc  near
; get video state
          mov ah,15
          int 10h
          mov bhpage,bh
          mov ah,3
          mov bh,bhpage
          int  10h
          mov  cursor,dx
          mov  cursmode,cx
          ret
getcurs   endp
retcurs   proc  near
          mov ah,2
          mov  dx,cursor
          mov bh,bhpage
          int  10h
          ret
retcurs   endp
; the tone routines produce glisandos based on the value of si
blip    proc  near
        push  si
        mov   si,30
        call  tone
        pop   si
        ret
blip    endp
blop    proc  near
        push  si
        mov   si,-30
        call  tone
        pop   si
        ret
blop    endp
tone    proc  near
        push  ax
        push  bx
        push  cx
        push  dx
        mov   dx,3    ; tone rate
        mov   bx,240  ; starting freq
        mov   cx,750  ; ending frequency
        cmp   si,0
        jg    do_blip
; here we do blop
        mov   bx,630  ; starting freq
        mov   cx,150  ; ending frequency
do_blip:
; turn on tone
i0:
        push  cx
        push  bx
        in     al,61h
        or     al,3
        out    61h,al
; loop parameters
        mov    cx,bx
 ; set frequency
        mov    dx,12h
        mov    ax,34deh
        div    cx
        mov    cx,ax
; set tone
        mov    al,cl
        out    42h,al
        mov    al,ch
        out    42h,al
i2:     loop i2
        pop    bx
        pop    cx
        cmp    bx,cx
        je     ip3
        add    bx,si
        jmp    i0
ip3:
 ;turn off tone
        in  al,61h
        and al,11111100b
        out 61h,al
        pop  dx
        pop  cx
        pop  bx
        pop  ax
        ret
tone    endp
setpass  proc  near
; set up a local stack
        lea  sp,stack+510
; get the screen
        call  getcurs
        mov   bx,0b800h
        cmp   al,4
        jle   got_mode
        mov   bx,0b000h
        cmp   al,7
        je    got_mode
        int   20h
got_mode:
        mov   mode,bx
        lea   di,screen
        mov   si,0
        push  ds
        mov   cx,25*80
        cld
        mov  ds,bx
rep     movsw
        pop   ds
if  passthru
;
;  prepare for the exec function
; shrink memory
   lea   bx,last_byte    ; last byte of program
   add   bx,15           ; trick to round up
   mov   cl,4
   shr   bx,cl           ; divide by 16 to get number of 16 byte blocks
   mov   ah,4ah          ; shrink
   int   21h
; create the commandline
;
; the command line has to start with /C and then the command
; and then end with a carriage return. It must have a byte at
; the front saying how long it is
   cld
   lea   di,command_line+1
   mov   al,'/'
   stosb
   mov   al,'C'
   stosb
   mov   al,' '
   stosb
; now copy the real command line in
   mov   si,81h
   mov   cl,byte ptr ds:[80h]
   mov   ch,0
   push  cx
   cmp   cx,0
   je    no_move
   cld
rep movsb
no_move:
   pop   cx
   add   cx,3
   mov   command_line,cl
; set up the control block with segment information
   mov    tailds,ds
   mov    fcb1,ds
   mov    fcb2,ds
;
; find the comspec
;
   mov    es,word ptr  ds:[2ch]
   mov     di,0
   mov     cx,255
env_loop:
   cld
   mov   al,'='
repne   scasb
; if there is no comspec, there is something wrong with the system
   cmp   word ptr es:[di-3],'CE'
   jne   env_loop
   cmp   word ptr es:[di-5],'PS'
   jne   env_loop
   cmp   word ptr es:[di-7],'MO'
   jne   env_loop
   cmp   byte ptr es:[di-8],'C'
   jne   env_loop
; got the comspec
;
; save the stack
;
   mov   savess,ss
   mov   savesp,sp
;
; set up the segment registers
;
; the comspec segment is in ES and should be in DS
;
   push  es
   pop   ds
   push  cs
   pop   es
   mov   dx,di
   lea   bx,parmblock
   mov   al,0
   mov   ah,4bh
; execute the thing
   int   21h
; here is where we return
   mov   ss,cs:savess
   mov   sp,cs:savesp
   mov   ax,cs
   mov   ds,ax
   mov   ax,mode
   mov   es,ax
   mov   di,0
   lea   si,screen
method3:
; this move the screen down
  add    si,3840  ; bottom line
  mov    cx,25  ; count of lines
m3loop:
  call   waitx
  push   cx
; scroll the screen down one
  push   si
  mov  ax,0701h
  mov  dx,184fh
  mov  cx,0
  mov  bx,0700h
  int  10h
  pop   si
; mov a line into place
  push  si
  mov   di,0
  mov   cx,80
  cld
rep movsw
  pop   si
  sub   si,160
   pop   cx
   loop  m3loop
   call  retcurs
   int   20h
method2:
; this method scatters the words to the screen
   mov   cx,50
   mov   bx,94
   mov   bp,0
m2loop:
  push  cx
  mov   cx,40
m2loop1:
  push  cx
  call   addx
  pop   cx
  loop m2loop1
  call waitx
   pop   cx
   loop  m2loop
   call  retcurs
   int  20h
waitx:
    push  cx
w1:
   mov   ax,0
   int   1ah
   cmp   dx,bp
   je    w1
   mov   bp,dx
   pop   cx
   ret
addx:
   add   bx,374
   cmp   bx,4000
   jl    okm2
   sub   bx,4000
okm2:
   call  movx
   ret
movx:
   mov   ax,word ptr ds:[si+bx]
   mov   word ptr es:[di+bx],ax
   ret
method1:
   mov   cx,25*80
   cld
rep  movsw
   call  retcurs
;

;
endif
     int  20h
setpass  endp
last_byte equ this byte
CSEG        ENDS
        END        ENTPT
