; this is a program which tries to read 512 bytes at a time and do
; a huffman
print macro string
    mov   ah,9
    lea   dx,string
    int   21h
    endm
cseg segment para public 'CODE'
assume  cs:cseg,ds:cseg
      org   100h
entry:  jmp   main
sig   db 26,"KG"
filename  db 64 dup(0)
ofilename db 64  dup(0)
handlei   dw 0
handleo   dw 0
e1   db 'Bad file name',13,10,'$'
e2   db 'File not found',13,10,'$'
e3   db 'Error creating output file',13,10,'$'
e4   db 'Error Writing output file header',13,10,'$'
e5   db 'Error opening input file',13,10,'$'
e6   db 'Error reading input file',13,10,'$'
e7   db 'Error writing output file',13,10,'$'
buffer   db  512  dup(0)
buffero  db  1024 dup(0)
table    dw  257  dup(0)
atable   dw  257  dup(0)
ttable   db  256  dup(0)
ecount   dw  0   ; count of entries
ocount   dw  0   ; count of output buffer size
huff    equ this byte
; table works like this:
; all strings beginning with 1 are themselves and 9 bits long
; all string beginning with 0 are decoded according to the
; fixed huffman table
   db  01100000b  ; 011      length 3
   db  00110000b  ; 0011     length 4
   db  00011000b  ; 00011    length 5
   db  01011000b  ; 00011    length 5
   db  00001100b  ; 000011   length 6
   db  00101100b  ; 000011   length 6
   db  01001100b  ; 000011   length 6
   db  00000110b  ; 001100   length 7
   db  00010110b  ; 001100   length 7
   db  00100110b  ; 001100   length 7
   db  01000110b  ; 001100   length 7
   db  01010110b  ; 001100   length 7
   db  00000000b  ; rest are 8
   db  00000001b
   db  00000010b
   db  00000011b
   db  00000100b
   db  00000101b
   db  00001000b
   db  00001001b
   db  00001010b
   db  00001011b
   db  00010000b
   db  00010001b
   db  00010010b
   db  00010011b
   db  00010100b
   db  00010101b
   db  00100000b
   db  00100001b
   db  00100010b
   db  00100011b
   db  00100100b
   db  00100101b
   db  00101000b
   db  00101001b
   db  00101010b
   db  00101011b
   db  01000000b
   db  01000001b
   db  01000010b
   db  01000011b
   db  01000100b
   db  01000101b
   db  01001000b
   db  01001001b
   db  01001010b
   db  01001011b
   db  01010000b
   db  01010001b
   db  01010010b
   db  01010011b
   db  01010100b
   db  01010101b
huffl  db 3,3,5,5,6,6,6,7,7,7,7,7
       db  42  dup(8)
main:
; strategey:
;  1) parse command line to get the file to compress
   call   parse
;  2) get file stats
   call   stats
;  2a) write out sq header
   call   fhead
;  2b) open file for input
   call   openin
read_loop:
;  3) read 512 bytes into buffer
   call   read_file
   jc     done_read
;  4) clean accumulator
   call   cleant
;  5) get byte counts for each byte type
   call   countt
;  6) sort tree, creates tables for compression
   call   sortt
;  7) write tree
   call write_tree
;  8) compress
   call  compress
;  9) write compress
   call  write_file
   jmp  read_loop
done_read:
     int   20h
write_file:
    mov   ah,40h
    mov   bx,handleo
    mov   cx,2
    lea   dx,ocount
    int   21h
    jc    error8
    mov   ah,40h
    mov   bx,handleo
    mov   cx,ocount
    lea   dx,buffero
    int   21h
    jc    error8
    cmp   ax,cx
    jne   error8
    clc
    ret
error8:
   print  e7
   stc
   int  20h
compress:
; compress the item in buffer
     lea   si,buffer
     lea   di,buffero
     mov   dx,0
     mov   bp,0
     mov   cx,512
c1:
     push   cx
     lodsb
     mov   bl,al
     mov   bh,0
     mov   bl,ttable[bx]
     cmp   bl,-1
     je    c6     ; is longer than calculated
     cmp   bx,54
     jge   c6
; ax has the frequency of the character from buffer
     mov   cl,huffl[bx]
     mov   ch,0
     mov   al,huff[bx]
     add   bp,cx
     cmp   cx,8
     je    c3
     shl   dx,cl
     sub   cx,8
     neg   cx
     shr   al,cl
     or    dl,al
     call  fixdl
     jmp   c8
c3:
     mov   dh,dl
     mov   dl,al
     call  fixdl
     jmp   c8
c6:
; this rotates 9 bits into dx
     shl   dx,1
     or    dl,1
     inc   bp
     call  fixdl
c7:
     mov  dh,dl
     mov  dl,al
     add  bp,8
     call  fixdl
c8:
     pop    cx
     loop   c1
; here we may have something left in dl
     cmp    bp,0
     je     c9
     mov   byte ptr ds:[di],dl
     inc   di
c9:
; di points to last byte written
     sub   di,offset buffero
     mov   ocount,di
     ret
fixdl:
     cmp   bp,8
     jl    fixdl1
     je    fixdl8
     mov   cx,16
     sub   cx,bp
     shl   dx,cl
     mov   al,dl
     mov   byte ptr ds:[di],dh
     mov   dl,al
     inc   di
     sub   bp,8
     ret
fixdl8:
     mov   byte ptr ds:[di],dl
     inc   di
     mov   bp,0
fixdl1:
     ret
write_tree:
; compress the tree a little
     lea   si,atable
     mov   di,si
     mov   cx,ecount
     cmp   ecount,54
     jle   wt1
     mov   cx,54
     mov   ecount,cx
wt1:
     lodsw
     stosb
     loop   wt1
     lea    dx,ecount
     mov    cx,1
     mov    bx,handleo
     mov    ah,40h
     int    21h
     jc     error7
     cmp    ax,cx
     jne    error7
     lea    dx,atable
     mov    cx,ecount
     mov    ah,40h
     mov    bx,handleo
     int    21h
     jc     error7
     cmp    ax,cx
     jne    error7
     clc
     ret
error7:
   print  e7
   stc
   int  20h
;
;  support procedures
;
sortt:
; the table has the count of individual bytes
; sorting here is to get atable in
; in order of the occurances, bigest first,
; step one is to mov all zero occurences to end
   mov   si,0
sl0:
   mov   ax,table[si]
   cmp   ax,0
   jne   sl1
; have a zero, it must be move
   mov   cx,512
   sub   cx,si
   shr   cx,1
   dec   cx
   lea   di,table
   inc   di
   inc   di
   add   di,si
repe  scasw
   je   done_sl
   dec   di
   dec   di
; si points to a zero
   xchg  word ptr ds:[di],ax
   mov   ds:table[si],ax
;  now fix up the atable
   mov   bx,si
   mov   ax,atable[bx]
   sub   di,offset table
   xchg  atable[di],ax
   mov   atable[bx],ax
sl1:
   inc   si
   inc   si
   cmp   si,510
   jge   done_sl
   jmp   sl0
done_sl:
; finished the moves
   shr   si,1
   dec   si
; si has the number of entries
   mov   ecount,si
   mov   cx,si
   mov   si,0
; have to bubble sort the guys down
sort1:
   cmp  table[si],0
   je   sort4
   mov   di,si
sort1a:
   inc   di
   inc   di
   cmp   di,510
   jge   sort3
   cmp   table[di],0
   je    sort3
   mov   ax,table[si]
   cmp   table[di],ax
   jle   sort2
; do the swap
   xchg  table[di],ax
   xchg  table[si],ax
   mov   ax,atable[si]
   xchg  atable[di],ax
   mov   atable[si],ax
sort2:
   jmp   sort1a
sort3:
; done with current si
   inc   si
   inc   si
   jmp   sort1
sort4:
; have finished the atable, now have to invert it into ttable
   mov   dx,0
   lea   si,atable
   mov   cx,54
st4:
   lodsw
   mov  di,ax
   mov  ttable[di],dl
   inc  dl
   inc  dl
   loop  st4
   mov cx,202
   mov  di,si
   mov  al,-1
rep  stosb
; done with everyone
   ret
countt:
   lea   si,buffer
   mov   cx,512
counttl:
   mov   ah,0
   lodsb
   shl   ax,1
   mov   bx,ax
   inc   table[bx]
   loop   counttl
   ret
cleant:
   lea   di,table
    mov  ax,0
   mov   cx,257
   cld
rep  stosw
; fill up the atable with characters
   lea  di,atable
   mov  al,0
   mov  cx,256
atloop:
   stosw
   inc  al
   loop  atloop
   ret
read_file:
   lea   dx,buffer
   mov   cx,512
   mov   ah,3fh
   mov   bx,handlei
   int   21h
   jc    error6
   cmp   ax,0
   je    read0
   clc
   ret
error6:
   print  e6
   stc
   int  20h
read0:
   stc
   ret
openin:
    lea   dx,filename
    mov   ah,3dh
    mov   al,0
    int   21h
    jc   error5
    mov  handlei,ax
    clc
    ret
error5:
    print e5
    stc
    int   20h
fhead:
; writes out the file header
   cld
   lea   si,filename
   lea   di,ofilename
fhead1:
   lodsb
   cmp   al,0
   je    done_fhname
   cmp   al,'.'
   je    done_fhname
   stosb
   jmp   fhead1
done_fhname:
   mov   al,'.'
   stosb
   mov  ax,'@@'
   stosw
   mov  ah,0
   stosw
; creat the file
  lea   dx, ofilename
  mov   cx,0
  mov   ah,3ch
  mov   al,0
  int  21h
  jnc  good_crea
  print  e3
  int  20h
good_crea:
   mov   handleo,ax
; write out the found header information
   lea   dx,sig
   mov   cx,3
   mov   bx,handleo
   mov   ah,40h
   int   21h
   mov   dx,80h+21
   mov   cx,21
   mov   bx,handleo
   mov   ah,40h
   int   21h
   jc    error4
   clc
   ret
error4:
   stc
   print  e4
   int   20h
stats:
   lea  dx,filename
   mov   ah,4eh
   mov   cx,0
   int   21h
   jc    error2
   clc
   ret
error2:
   print   e2
   stc
   int  20h
parse:
   lea  di,filename
   mov  si,81h
   cld
space1:
   lodsb
   cmp  al,13
   je   error1
   cmp  al,' '
   je   space1
space2:
   stosb
   lodsb
   cmp   al,13
   je    done_p
   cmp   al,' '
   je   done_p
   jmp   space2
done_p:
   clc
   ret
error1:
   print e1
   stc
   int   20h
cseg  ends
    end   entry
